<?php
    @session_start( );
    $AjaxFunctions['updateDataChannels'] = 'updateDataChannels';

    function updateDataChannels( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        $link = isset( $_REQUEST['linkNow'] ) ? $_REQUEST['linkNow'] : NULL;
        $board = isset( $_REQUEST['boardNow'] ) ? $_REQUEST['boardNow'] : NULL;
        $gc = isset( $_REQUEST['gc'] ) ? $_REQUEST['gc'] : NULL;

        if( isset( $link ) && isset( $board ) && isset( $gc ) )
        {
            try
            {
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    $deviceList = $_SESSION['DeviceList'];
                    $gc = explode( '|', $gc );

                    if( $gc[0] != '' && $gc[1] != '' )
                        $tmp = Populator::populateChannels( $deviceList[$board], $link, $gc[0], $gc[1] );
                    else
                        $tmp = Populator::populateChannels( $deviceList[$board], $link );

                    if( $tmp != $deviceList[$board] )
                    {
                        $deviceList[$board] = $tmp;
                        $_SESSION['DeviceList'] = $deviceList;
                        $ret = array( 0 => $tmp, 'linkNow' => $link );
                    }

                    $ret['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $ret );
                }
                else
                {
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < $CountDevices; $i++ )
                    {
                        $device = array( 'serial' => '', 'model' => '', 'board' => $i, 'links' => array( ) );
                        $device = Populator::prePopulateChannels( $device );
                        $deviceList[$i] = $device;
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $deviceList['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $deviceList );
                }
            }
            catch(Exception $e)
            {
                $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
                return JSONencode( $ret );
            }
        }
    }