<?php
    @session_start( );
    $AjaxFunctions['updateDataDevices'] = 'updateDataDevices';

    function updateDataDevices( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        try
        {
            if( Populator::isK3LConnected( ) )
            {
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    for( $i = 0; $i < count( $_SESSION['DeviceList'] ); $i++ )
                    {
                        $temp = Populator::populateDevice( $_SESSION['DeviceList'][$i] );
                        if( $temp != $_SESSION['DeviceList'][$i] )
                        {
                            $_SESSION['DeviceList'][$i] = $temp;
                            $resposta[] = $temp;
                        }
                    }
                    $resposta['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $resposta['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $resposta );
                }
                else
                {
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < (int)$CountDevices; $i++ )
                    {
                        $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                        $device = Populator::populateDevice( $device );
                        $deviceList[$i] = $device;
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $deviceList['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $deviceList );
                }
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }

        }
        catch(Exception $e)
        {
            $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
            $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
            return JSONencode( $ret );
        }
    }