<?php
    @session_start( );
    $AjaxFunctions['updateDataLinks'] = 'updateDataLinks';

    function updateDataLinks( $_REQUEST )
    {
        $app = KSystem::getInstance( );
        try
        {
            if( Populator::isK3LConnected( ) )
            {
                if( isset( $_SESSION['DeviceList'][0] ) )
                {
                    $deviceList = $_SESSION['DeviceList'];
                    $deviceUpdated = array( );
                    for( $i = 0; $i < count( $deviceList ); $i++ )
                    {
                        $tmp = Populator::populateLink( $deviceList[$i] );
                        if( $tmp != $deviceList[$i] )
                        {
                            $deviceList[$i] = $tmp;
                            $deviceUpdated[] = $tmp;
                        }
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $deviceUpdated['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $deviceUpdated['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $deviceUpdated );
                }
                else
                {
                    $deviceList = array( );
                    $CountDevices = 0;
                    $CountDevices = Populator::getDeviceCount( );
                    for( $i = 0; $i < (int)$CountDevices; $i++ )
                    {
                        $links_count = 0;
                        $links_count = Populator::getLinkCount( $i );
                        if( $links_count > 0 )
                        {
                            $device = array( 'model' => '', 'board' => $i, 'serial' => '', 'status' => '', 'links' => array( ) );
                            $device = Populator::populateLink( $device );
                            $deviceList[] = $device;
                        }
                    }
                    $_SESSION['DeviceList'] = $deviceList;
                    $deviceList['Message']['error'] = MonitorService::checkMediaServerMessages( );
                    $deviceList['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
                    return JSONencode( $deviceList );
                }
            }
            else
            {
                throw new Exception( 'k3lDown' );
            }
        }
        catch(Exception $e)
        {
            $ret['Message']['warning'] = $app->translate( MonitorService::getWarningMessage( ) );
            $ret['Message']['error'] = $app->translateErrMessage( Querist::$last_error );
            return JSONencode( $ret );
        }
    }