function RunFirmwareUpdate( upd )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=runFirmwareUpdate&update=" + upd,
        dataType : "html",
        success : function( retorno )
        {
            $( '#refreshing' ).hide( );
            $( '#todo' ).html( retorno );
            startCountdownReset( );
        }
    } );
}

var g_iCount = new Number( );
var g_iCount = 60;
var kgatewayrpc = $.rpc.service( "/rpc/json.fcgi/kgateway" );

function startCountdownReset( )
{
    if( (g_iCount - 1) > 0 )
    {
        g_iCount = g_iCount - 1;
        $( '#time-slot' ).text( g_iCount );
        setTimeout( 'startCountdownReset()', 1000 );
    }
    else
        window.location = "/index.php";
}

function newNAP( )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=newNAP",
        dataType : "html",
        success : function( html )
        {
            $( '#refreshing' ).hide( );
            $( '#NAPsDivForm' ).html( html );
        }
    } );
}

function initNAPs( )
{
    $( '#NAPsTable' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            3 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

function backNAPs( )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showNAPsGW",
        dataType : "html",
        success : function( html )
        {
            $( '#formulario' ).html( html );
            initNAPs( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function changeNAPType( )
{

    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=printNAPType",
        data :
        {
            'type' : $.trim( $( '#gateway-nap-type :selected' ).val( ) ),
            'name' : $.trim( $( '#gateway-nap-old-name' ).val( ) )
        },
        type : "POST",
        dataType : "html",
        success : function( html )
        {
            $( '#refreshing' ).hide( );
            $( '#gateway-nap' ).html( html );
            switch( $.trim( $( '#gateway-nap-type :selected' ).val( ) ) )
            {
                case 'Trunk':
                    $( '.gateway-nap-trunk-device select' ).change( function( ev )
                    {
                        if( $( this ).val( ) == 'partial' )
                        {
                            $( '#channels-' + $( this ).attr( 'name' ) ).show( );
                        }
                        else
                        {
                            $( '#channels-' + $( this ).attr( 'name' ) ).hide( );
                        }
                    } );
                    $( '.gateway-nap-trunk-device select' ).change( );
                    break;
                case 'SIP':
                    $( '#gateway-nap-sip-register' ).change( function( ev )
                    {
                        var disabled = ! $( this ).is( ':checked' );
                        $( '#gateway-nap-sip-username' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-authorization-user' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-password' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-expires' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-proxy' ).prop( 'disabled', disabled );
                        $( '#gateway-nap-sip-proxy-port' ).prop( 'disabled', disabled );
                    } );
                    $( '#gateway-nap-sip-domain-use-ip-packet-address' ).change( function( ev )
                    {
                        if( $( this ).is( ':checked' ) && !$( '#gateway-nap-sip-domain' ).val( ).isIpv4( ) )
                        {
                            ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-should-be-ipv4' ), false );
                            $( this ).attr( 'checked', false );
                        }
                    } );
                    $( '#gateway-nap-sip-domain-port' ).mask( '9?9999' );
                    $( '#gateway-nap-sip-proxy-port' ).mask( '9?9999' );
                    $( '#gateway-nap-sip-expires' ).mask( '9?999999999' );
                    $( '#gateway-nap-sip-register' ).change( );
                    break;
                case 'GSM':
                    $( '#gateway-nap-gsm-enable-track' ).change( function( ev )
                    {
                        if( $( this ).is( ':checked' ) )
                        {
                            $( "#gateway-nap-gsm-track-table" ).show();
                        }
                        else
                        {
                            $( "#gateway-nap-gsm-track-table" ).hide();
                        }
                    } ).change();
                    $( '#gateway-nap-gsm-minutes-swap-enabled' ).change( function( ev )
                    {
                        var $input = $( '#gateway-nap-gsm-minutes-swap' );
                        if( $( this ).is( ':checked' ) )
                        {
                            if( $input.val() == 0 )
                            {
                                $input.val( '' );
                            }
                            $input.show();
                        }
                        else
                        {
                            $input.val( 0 );
                            $input.hide();
                        }
                    } ).change();
                    $( '#gateway-nap-gsm-monthly-minutes' ).mask( '9?999999' );
                    $( '#gateway-nap-gsm-minutes-swap' ).mask( '9?999999' );
                    break;
            }
        }
    } );
}

function editNAP( NAPname )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=editNAP",
        data :
        {
            "name" : NAPname
        },
        type : 'POST',
        dataType : "html",
        success : function( html )
        {
            $( '#NAPsDivForm' ).html( html );
            changeNAPType( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function removeNAP( name )
{
    if( ajaxConfirm( 'removeNAP' ) )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=removeNAP',
            data :
            {
                "name" : name
            },
            type : 'POST',
            dataType : "json",
            success : function( data )
            {
                if( data.success )
                {
                    ShowNotice( data.message, true );
                    backNAPs( );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
                $( '#refreshing' ).hide( );
            }
        } );
    }
}

function construcQueryStrig( name, value )
{
    return name + '=' + value + '|';
}

function buildTeste( group )
{
    returnGroup = '';
    for( i = 0; i < group.length; i++ )
    {
        if( returnGroup == '' )
            returnGroup += group[i];
        else
            returnGroup += ',' + group[i];
        varTest = group[i];
        testVar = group[i];

        for( x = i; x < group.length; x++ )
        {
            if( testVar == group[x] )
            {
                testVar++;
                i++;
            }
        }
        i--;
        if( group[i] != varTest )
            returnGroup += '-' + group[i];
    }
    return returnGroup;
}

function saveNAP( )
{
    var mydata =
    {
        'Name' : $.trim( $( '#gateway-nap-name' ).val( ) ),
        'Type' : $( '#gateway-nap-type :selected' ).val( ),
        'oldName' : $( '#gateway-nap-old-name' ).val( )
    };

    if( mydata['Name'] == '' )
    {
        ShowNotice( ajaxI18N( 'gateway-nap-error-name-is-required' ), false );
        return;
    }

    var p = $.trim( $( '#gateway-nap-profile' ).val( ) );
    // Profile
    if( p != '' )
    {
        mydata['Profile'] = p;
    }
    delete p;

    // NAP type data
    switch( mydata['Type'] )
    {
        case 'SIP':
            mydata['Domain'] = $.trim( $( '#gateway-nap-sip-domain' ).val( ) );
            if( mydata['Domain'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-is-required' ), false );
                return;
            }
            mydata['DomainPort'] = $.trim( $( '#gateway-nap-sip-domain-port' ).val( ) );
            if( mydata['DomainPort'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-port-is-required' ), false );
                return;
            }
            mydata['DomainUseIpPacketAddress'] = $( '#gateway-nap-sip-domain-use-ip-packet-address' ).is( ':checked' );
            if( mydata['DomainUseIpPacketAddress'] && !mydata['Domain'].isIpv4( ) )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-domain-should-be-ipv4' ), false );
                return;
            }
            mydata['IgnoreSourcePort'] = $( '#gateway-nap-sip-ignore-source-port' ).is( ':checked' );
            mydata['UseCalledFromRequestURI'] = $( '#gateway-nap-sip-use-called-from-uri' ).is( ':checked' );
            mydata['SipTransportType'] = $('#gateway-nap-sip-sip-transport-type').val();
            mydata['AudioTransportType'] = $('#gateway-nap-sip-audio-transport-type').val();
            mydata['Proxy'] = $.trim( $( '#gateway-nap-sip-proxy' ).val( ) );
            mydata['ProxyPort'] = $.trim( $( '#gateway-nap-sip-proxy-port' ).val( ) );
            mydata['Register'] = $( '#gateway-nap-sip-register' ).is( ':checked' );
            mydata['Username'] = $.trim( $( '#gateway-nap-sip-username' ).val( ) );
            if( mydata['Register'] && mydata['Username'] == '' )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-error-sip-username-is-required' ), false );
                return;
            }
            mydata['AuthorizationUser'] = $.trim( $( '#gateway-nap-sip-authorization-user' ).val( ) );
            mydata['Password'] = $.trim( $( '#gateway-nap-sip-password' ).val( ) );
            mydata['Expires'] = $.trim( $( '#gateway-nap-sip-expires' ).val( ) );
            break;
        case 'Trunk':
            mydata['Links'] = [];
            $( '.gateway-nap-trunk-device select' ).each( function( idx, elm )
            {
                switch( $( this ).val() )
                {
                    case 'full':
                        mydata['Links'].push( $( this ).attr( 'id' ) );
                        break;
                    case 'partial':
                        $( '#channels-' + $( this ).attr( 'name' ) + ' input:checked' ).each( function( idx, elm )
                        {
                            mydata['Links'].push( $( elm ).attr( 'id' ) );

                        } );
                        break;
                }

            } );
            if( mydata['Links'].length == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-trunk-error-link-or-channel-required' ), false );
                return;
            }
            break;
        case 'GSM':
            var timetrackenabled = $( '#gateway-nap-gsm-enable-track' ).is( ':checked' );
            mydata['MonthlyMinutes'] = $.trim( $( '#gateway-nap-gsm-monthly-minutes' ).val( ) );

            if( timetrackenabled && mydata['MonthlyMinutes'] == '' )
            {
                return ShowNotice( ajaxI18N( 'gateway-nap-gsm-monthly-minutes-required' ) );
            }

            mydata['MinutesToSwap'] = $.trim( $( '#gateway-nap-gsm-minutes-swap' ).val( ) );
            if( mydata['MinutesToSwap'] == '' )
            {
                return ShowNotice( ajaxI18N( 'gateway-nap-gsm-minutes-swap-required' ) );
            }

            mydata['ContractDay'] = $.trim( $( '#gateway-nap-gsm-contract-day' ).val( ) );
            mydata['SharedMinutes'] = $( '#gateway-nap-gsm-shared-minutes' ).is( ':checked' );
            if( timetrackenabled )
            {
                if( $.trim( $('#gateway-nap-gsm-time-track-pattern-option').val() ) == '' )
                {
                    return ShowNotice( ajaxI18N( 'gateway-nap-gsm-time-track-pattern-required' ) );
                }
                mydata['TimeTrackPattern'] = $.trim( $('#gateway-nap-gsm-time-track-pattern-option').val( ) );
            }
            else
            {
                mydata['TimeTrackPattern'] = '';
            }

            mydata['SIMs'] = [];

            $( '#gateway-nap-sim-card-list input:checked' ).each( function( idx, elm )
            {
                mydata['SIMs'].push( $( elm ).attr( 'name' ) );
            } );

            break;
        case 'FXO':
            mydata['Channels'] = [];
            $( '[class~="gateway-nap-fxo-channel"]:checked' ).each( function( idx, elm )
            {
                mydata['Channels'].push( $( elm ).attr( 'id' ) );
            } );
            if( mydata['Channels'].length == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-fxo-error-channel-required' ), false );
                return;
            }
        case 'FXS':
            mydata['Branches'] =
            {
            };
            var count = 0;
            $( '[class~="gateway-nap-fxs-branch"]' ).each( function( idx, elm )
            {
                if( $( elm ).val( ) != '' )
                {
                    mydata['Branches'][$( elm ).attr( 'id' )] = $( elm ).val( );
                    count++;
                }
            } );
            if( count == 0 )
            {
                ShowNotice( ajaxI18N( 'gateway-nap-fxs-error-branch-required' ), false );
                return;
            }
            delete count;
            break;
        default:
            ShowNotice( ajaxI18N( 'gateway-nap-error-type-is-required' ), false );
            return;
    }
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL + '&ajaxTo=saveNAP',
        data : mydata,
        dataType : "json",
        type : "POST",
        success : function( data )
        {
            $( '#refreshing' ).hide( );
            if( data.success )
            {
                ShowNotice( data.message, true );
                backNAPs( );
            }
            else
            {
                ShowNotice( data.message, false );
            }
        },
        error : ajaxDefaultError
    } );
}

function initTimeRestraints( )
{
    $( '#TimeRestraintsTable' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            1 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

function backTimeRestraints( )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=showTimeRestraintsGW",
        dataType : "html",
        success : function( html )
        {
            $( '#formulario' ).html( html );
            initTimeRestraints( );
        }
    } );
    $( '#refreshing' ).hide( );
}

function removeTimeRestraints( name )
{
    if( ajaxConfirm( 'removeTimeRestraints' ) )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=removeTimeRestraintsGW",
            data :
            {
                'name' : name
            },
            dataType : "json",
            type : 'POST',
            success : function( data )
            {
                ShowNotice( data.message, data.success );
                if( data.success )
                {
                    backTimeRestraints( );
                }
            }
        } );
        $( '#refreshing' ).hide( );
    }
}

function newTimeRestraints( )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL,
        data : "ajaxTo=newTimeRestraintsGW",
        dataType : "html",
        success : function( retorno )
        {
            $( '#TimeRestraintsDivTable' ).html( retorno );
            ApplyDropDownCheckBox( );
        }
    } );
    $( '#refreshing' ).hide( );
}

function editTimeRestraints( name )
{
    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL + '&ajaxTo=editTimeRestraintsGW',
        data :
        {
            name : name
        },
        type : 'POST',
        dataType : 'html',
        success : function( retorno )
        {
            $( '#TimeRestraintsDivTable' ).html( retorno );
            ApplyDropDownCheckBox( );
            $( '#refreshing' ).hide( );
        }
    } );
}

function validaHorario( )
{
    var fromHour = $( "#fromHour" ).val( );
    fromHour[0] == '0' ? fromHour = fromHour[1] : '';

    var toHour = $( "#toHour" ).val( );
    toHour[0] == '0' ? toHour = toHour[1] : '';

    var fromMin = $( "#fromMinutes" ).val( );
    fromMin[0] == '0' ? fromMin = fromMin[1] : '';

    var toMin = $( "#toMinutes" ).val( );
    toMin[0] == '0' ? toMin = toMin[1] : '';

    var erros = 0;

    if( fromHour == '' || toHour == '' || fromMin == '' || toMin == '' || isNaN( fromHour ) || isNaN( toHour ) || isNaN( fromMin ) || isNaN( toMin ) )
        erros++;

    if( fromHour < 0 || fromHour > 24 )
        erros++;

    if( toHour < 0 || toHour > 24 )
        erros++;

    if( fromMin < 0 || fromMin > 59 )
        erros++;

    if( toMin < 0 || toMin > 59 )
        erros++;

    if( erros > 0 )
    {
        ajaxAlert( 'reportValidTime' );
        return false;
    }
    else
        return true;
}

function saveTimeRestraints( )
{
    var data = '';
    var TimeRestraintsId = $( "#TimeRestraintsId" ).val( );
    var TimeRestraintsPos = $( "#TimeRestraintsPos" ).val( );
    var name = $.trim( $( "#timeRestraintsName" ).val( ) );

    if( name == '' )
    {
        ajaxAlert( 'reportNameRestraints' );
        return false;
    }
    data += construcQueryStrig( "Name", name );

    //horario
    var hour = '';
    if( $( '#checkHour' ).is( ':checked' ) )
    {
        if( !validaHorario( ) )
            return false;

        var hour = $( "#fromHour" ).val( ) + ':' + $( "#fromMinutes" ).val( );
        hour += '-';
        hour += $( "#toHour" ).val( ) + ':' + $( "#toMinutes" ).val( );
    }

    data += construcQueryStrig( "Hour", hour );

    //dias da semana
    var wdays = '';
    if( $( '#checkWeekDay' ).is( ':checked' ) )
    {
        if( $( '#weekDay-combo' ).val( ) != null )
            wdays = $( '#weekDay-combo' ).val( );
        if( wdays == '' )
        {
            ajaxAlert( 'reportWeekDay' );
            return false;
        }
    }
    data += construcQueryStrig( "WDay", wdays );

    //dias do mes
    var days = '';
    if( $( '#checkMonthDay' ).is( ':checked' ) )
    {
        $( '#monthDayTable input[type="checkbox"]' ).each( function( )
        {
            if( $( this ).is( ':checked' ) )
                days += $( this ).val( ) + ',';
        } );
        //clear the last coma
        days = days.substr( 0, days.length - 1 );
        if( days == '' )
        {
            ajaxAlert( 'reportMonthDay' );
            return false;
        }
    }
    data += construcQueryStrig( "Day", days );

    //meses
    var months = '';
    if( $( '#checkMonth' ).is( ':checked' ) )
    {
        if( $( '#month-combo' ).val( ) != null )
            months = $( '#month-combo' ).val( );
        if( months == '' )
        {
            ajaxAlert( 'reportMonth' );
            return false;
        }
    }
    data += construcQueryStrig( "Month", months );
    //clear the last pipe
    data = data.substr( 0, data.length - 1 );

    $( '#refreshing' ).show( );
    $.kajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=saveTimeRestraintsGW",
        data :
        {
            id : TimeRestraintsId,
            TimeRestraintsPos : TimeRestraintsPos,
            data : data
        },
        type : 'POST',
        dataType : 'text',
        success : function( retorno )
        {
            retorno = retorno.replace( /(\r\n|\n|\r)/gm, "" );
            resp = retorno.split( '|' );
            $( '#refreshing' ).hide( );
            if( resp[0] == 'ok' )
            {
                ShowNotice( resp[1], true );
                backTimeRestraints( );
            }
            else
            {
                ShowNotice( resp[1], false );
            }
        }
    } );
}

function setPosition( pos, id )
{
    $( '#' + id + 'Position' ).val( pos );
}

function normalizeField( id )
{
    var v = $( '#' + id ).val( );
    if( v.length < 2 )
        var v = $( '#' + id ).val( '0' + (v) );
}

function up( id )
{
    if( $( '#' + id + 'Position' ).val( ) == 'hour' )
    {
        var campo = $( '#' + id + 'Hour' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var hour = parseInt( campo );
            if( hour <= 22 )
                $( '#' + id + 'Hour' ).val( hour + 1 );
            if( hour >= 23 )
                $( '#' + id + 'Hour' ).val( 0 );
        }
        else
            $( '#' + id + 'Hour' ).val( 0 );
        normalizeField( id + 'Hour' );
    }
    else
    {
        var campo = $( '#' + id + 'Minutes' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var minutes = parseInt( campo );
            if( minutes == '' )
                $( '#' + id + 'Minutes' ).val( 0 );
            if( minutes <= 58 )
                $( '#' + id + 'Minutes' ).val( minutes + 1 );
            if( minutes >= 59 )
                $( '#' + id + 'Minutes' ).val( 0 );
        }
        else
            $( '#' + id + 'Minutes' ).val( 0 );

        normalizeField( id + 'Minutes' );

    }
}

function down( id )
{
    if( $( '#' + id + 'Position' ).val( ) == 'hour' )
    {
        var campo = $( '#' + id + 'Hour' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var hour = parseInt( campo );
            if( hour == '' )
                $( '#' + id + 'Hour' ).val( 0 );
            if( hour <= 23 )
                $( '#' + id + 'Hour' ).val( hour - 1 );
            if( hour == 0 )
                $( '#' + id + 'Hour' ).val( 23 );
            if( hour > 23 )
                $( '#' + id + 'Hour' ).val( 0 );
        }
        else
            $( '#' + id + 'Hour' ).val( 0 );

        normalizeField( id + 'Hour' );
    }
    else
    {
        var campo = $( '#' + id + 'Minutes' ).val( );
        if( campo != '' && !isNaN( campo ) )
        {
            if( campo[0] == '0' )
                campo = campo[1];
            var minutes = parseInt( campo );
            if( minutes == '' )
                $( '#' + id + 'Minutes' ).val( 0 );
            if( minutes <= 59 )
                $( '#' + id + 'Minutes' ).val( minutes - 1 );
            if( minutes == 0 )
                $( '#' + id + 'Minutes' ).val( 59 );
            if( minutes > 59 )
                $( '#' + id + 'Minutes' ).val( 0 );
        }
        else
            $( '#' + id + 'Minutes' ).val( 0 );

        normalizeField( id + 'Minutes' );
    }
}

function showHourTable( )
{
    if( $( '#checkHour' ).is( ':checked' ) )
        $( '#hourTable' ).show( );
    else
        $( '#hourTable' ).hide( );
}

function showWeekDaysTable( )
{
    if( $( '#checkWeekDay' ).is( ':checked' ) )
    {
        $( '#weekDayTable' ).show( );
        $( "#ddcl-weekDay-combo" ).show( );
    }
    else
    {
        $( '#weekDayTable' ).hide( );
        $( "#ddcl-weekDay-combo" ).hide( );
    }
}

function showMonthDayTable( )
{
    if( $( '#checkMonthDay' ).is( ':checked' ) )
        $( '#monthDayTable' ).show( );
    else
        $( '#monthDayTable' ).hide( );
}

function showMonthTable( )
{
    if( $( '#checkMonth' ).is( ':checked' ) )
    {
        $( '#monthTable' ).show( );
        $( "#ddcl-month-combo" ).show( );
    }
    else
    {
        $( '#monthTable' ).hide( );
        $( "#ddcl-month-combo" ).hide( );
    }
}

function autoCompleteFXS( serial )
{
    var reply = $.trim( ajaxPrompt( 'enterFirstBranche' ) );
    if( isNumeric( reply ) && reply != '' )
    {
        $( '#branches-' + serial + ' input[type="text"]' ).each( function( )
        {
            $( this ).attr( "value", reply );
            reply++;
        } );
    }
}

function cleanFXS( serial )
{
    if( ajaxConfirm( 'cleanTypedBranches' ) )
    {
        $( '#branches-' + serial + ' input[type="text"]' ).each( function( )
        {
            $( this ).attr( "value", '' );
        } );
    }
}

function ApplyDropDownCheckBox( )
{
    var select = ajaxI18N( 'selectOne' );
    var close = ajaxI18N( 'closeDropDown' );
    $( "#weekDay-combo" ).dropdownchecklist(
    {
        emptyText : select + "...",
        explicitClose : close + ' [x]',
        width : 200,
        icon :
        {
        },
        maxDropHeight : 150
    } );

    $( "#month-combo" ).dropdownchecklist(
    {
        emptyText : select + "...",
        explicitClose : close + ' [x]',
        width : 200,
        icon :
        {
        },
        maxDropHeight : 250
    } );
    showWeekDaysTable( );
    showMonthTable( );
}

function initNetworkGW( )
{
    var nrifaces = $( '.gateway-network-interface-method' ).length;

    if( nrifaces == 1 )
    {
        // change dns configuration method event handler
        $( '#gateway-network-dns-method' ).change( function( )
        {
            if( $( this ).val( ) == 'static' )
            {
                $( '#gateway-network-dns-config' ).show( );
            }
            else
            {
                $( '#gateway-network-dns-config' ).hide( );
            }
        } );
        $( '#gateway-network-dns-method' ).change( );
    }

    // change network configuration method event handler
    $( '.gateway-network-interface-method' ).each( function( idx, elm )
    {
        var iface = $( elm ).attr( 'id' ).split( '-' ).pop( );

        $( elm ).change( function( )
        {
            switch( $( this ).val( ) )
            {
                case 'manual':
                    // aka disabled
                    $( '#gateway-network-config-dhcp-' + iface ).hide( );
                    $( '#gateway-network-config-static-' + iface ).hide( );
                    break;
                case 'dhcp':
                    $( '#gateway-network-config-dhcp-' + iface ).show( );
                    $( '#gateway-network-config-static-' + iface ).hide( );
                    if( nrifaces == 1 )
                    {
                        $( '#gateway-network-dns-method' ).prop( 'disabled', false );
                    }
                    break;
                case 'static':
                    $( '#gateway-network-config-static-' + iface ).show( );
                    $( '#gateway-network-config-dhcp-' + iface ).hide( );
                    if( nrifaces == 1 )
                    {
                        $( '#gateway-network-dns-method' ).val( 'static' );
                        $( '#gateway-network-dns-method' ).change( );
                        $( '#gateway-network-dns-method' ).prop( 'disabled', true );
                    }
                    break;
                default:
                    console.warn( "unsupported [interface] method for " + iface );
                    return;
            }
        } );
        $( elm ).change( );
    } );

    // append dns server input text
    $( '.gateway-network-dns-add' ).click( function( ev )
    {
        var _input = $( '<input type=\'text\' class=\'gateway-network-dns-server ipv4\' />' );
        _input.ipAddress( );
        $( '#gateway-network-dns-server-list' ).append( _input );
        $( '#gateway-network-dns-server-list' ).append( '<br />' );
        ev.preventDefault( );
    } );
    // save network configuration event
    $( '#gateway-network-save' ).click( function( )
    {
        try
        {
            var config =
            {
                'ifaces' :
                {
                }
            };

            // network interfaces + dns
            $( '.gateway-network-interface' ).each( function( idx, elm )
            {
                var getIpv4 = function( element )
                {
                    return $( element ).val( ).isIpv4( ) ? $( element ).val( ) : "";
                };
                var iface = $( this ).attr( 'id' ).split( '-' ).pop( );
                var ifacedata =
                {
                    'config' :
                    {
                    },
                    'properties' :
                    {
                        'method' : $( '#gateway-network-method-' + iface + ' :selected' ).val( ),
                        'family' : 'inet'
                    }
                };

                switch( ifacedata['properties']['method'] )
                {
                    case 'static':
                        ifacedata['config'] =
                        {
                            'address' : getIpv4( '#gateway-network-static-address-' + iface ),
                            'netmask' : getIpv4( '#gateway-network-static-netmask-' + iface ),
                            'gateway' : getIpv4( '#gateway-network-static-gateway-' + iface )
                        };
                        if( ifacedata['config']['address'].length == 0 )
                        {
                            throw 'gateway-network-interface-error-address-required';
                        }
                        if( ifacedata['config']['netmask'].length == 0 )
                        {
                            throw 'gateway-network-interface-error-netmask-required';
                        }
                        break;
                    case 'dhcp':
                    case 'manual':
                        // aka disabled
                        break;
                    default:
                        console.warn( "unsupported [interface] method " + ifacedata['properties']['method'] + " for " + iface );
                        return;
                }

                switch( $( '#gateway-network-dns-method' ).val() )
                {
                    case 'static':
                        var nameservers = [];
                        $( '.gateway-network-dns-server' ).each( function( )
                        {
                            _ip = getIpv4( this );
                            if( _ip )
                            {
                                nameservers.push( _ip );
                            }
                        } );
                        ifacedata['config']['dns-search'] = $.trim( $( '#gateway-network-dns-search' ).val( ) );
                        ifacedata['config']['dns-nameservers'] = nameservers;
                        break;
                    case 'dhcp':
                        break;
                    default:
                        console.warn( "unsupported [dns] method for " + iface );
                        return;
                }

                config['ifaces'][iface] = ifacedata;
            } );

            $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=saveNetworkGW',
                data : config,
                dataType : 'json',
                type : 'post',
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            ShowNotice( ajaxI18N( err ), false );
        }
    } );

    // setup masks and validators
    $( '.ipv4' ).ipAddress( );
}

function initDateTimeGW( )
{
    // append ntp server input text
    $( '#gateway-datetime-ntp-add' ).click( function( ev )
    {
        $( '#gateway-datetime-ntp-server-list' ).append( '<input type=\'text\' class=\'gateway-datetime-ntp-server\' /><br />' );
        ev.preventDefault( );
    } );
    // save datetime configuration event
    $( '#gateway-datetime-save' ).click( function( )
    {
        try
        {
            var config =
            {
                'timezone' : $( '#gateway-datetime-timezone' ).val( ),
                'ntp' :
                {
                    'enabled' : $( '#gateway-datetime-ntp-enable' ).is( ':checked' ) ? 'yes' : 'no',
                    'timeout' : $( '#gateway-datetime-ntp-timeout' ).val( ),
                    'servers' : []
                }
            };

            // ntp servers
            $( '.gateway-datetime-ntp-server' ).each( function( )
            {
                _host = $.trim( $( this ).val( ) );
                if( _host.length > 0 )
                {
                    config['ntp']['servers'].push( _host );
                }
            } );

            // date and time
            if( $( '#gateway-datetime-date-changed' ).val( ) == 'yes' )
            {
                config['date'] = $( '#gateway-datetime-date' ).val( );
            }
            if( $( '#gateway-datetime-time-changed' ).val( ) == 'yes' )
            {
                config['time'] = $( '#gateway-datetime-time' ).val( );
            }

            $( '#refreshing' ).show( );
            $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=saveDateTimeGW',
                data : config,
                dataType : 'json',
                type : 'post',
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                },
                error : ajaxDefaultError
            } );
        }
        catch( err )
        {
            ShowNotice( ajaxI18N( err ), false );
        }
    } );

    // setup masks and validators
    $( '#gateway-datetime-date' ).mask( "99/99/9999" );
    $( '#gateway-datetime-time' ).mask( "99:99:99" );
    $( '#gateway-datetime-ntp-timeout' ).mask( "9?99" );
    // setup change notification
    $( '#gateway-datetime-date' ).change( function( )
    {
        $( '#gateway-datetime-date-changed' ).val( 'yes' );
    } );
    $( '#gateway-datetime-time' ).change( function( )
    {
        $( '#gateway-datetime-time-changed' ).val( 'yes' );
    } );
}

function shutdownGW( )
{
    if( ajaxConfirm( 'gateway-shutdown-confirm' ) )
    {
        $( '#gateway-power-wait .shutdown' ).show( );
        $( '#gateway-power-wait .reboot' ).hide( );
        var title = ajaxI18N( 'gateway-shutdown' ).toUpperCase( );
        var done = ajaxI18N( 'gateway-shutdown-done' );
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=shutdown',
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                if( data.success )
                {
                    var wait = $( '#gateway-power-wait' );
                    wait.dialog(
                    {
                        closeOnEscape : false,
                        draggable : false,
                        resizable : false,
                        title : title,
                        modal : true,
                        open : function( event, ui )
                        {
                            $( ".ui-dialog-titlebar-close", $( this ).parent( ) ).hide( );
                        }
                    } );
                    var countdown = function( v )
                    {
                        if( v == 0 )
                        {
                            wait.html( done );
                            return;
                        }
                        var b = '';
                        for( var i = 0; i < v; i++ )
                        {
                            b += '.';
                        }
                        $( '#gateway-power-wait .countdown' ).text( b );
                        setTimeout( countdown, 1000, v - 1 );
                    };
                    countdown( 10 );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
            }
        } );
    }
}

function remoteShellGW( )
{
    $( '#remote-shell-content' ).dialog(
    {
        closeOnEscape : true,
        draggable : false,
        resizable : false,
        modal : true,
        title : $( '#remote-shell' ).val( ),
        width : $( window ).width( ) - 400,
        height : $( document ).height( ) - 300,
        open : function( event, ui )
        {
            $( '#remote-shell-download-key' ).click( function( evt )
            {
                window.location.href = '/KWebConfig/?location=downloadShellKey';
            } );
        }
    } );
}

function rebootGW( )
{
    if( ajaxConfirm( 'gateway-reboot-confirm' ) )
    {
        $( '#gateway-power-wait .shutdown' ).hide( );
        $( '#gateway-power-wait .reboot' ).show( );
        var title = ajaxI18N( 'gateway-reboot' ).toUpperCase( );
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=reboot',
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                if( data.success )
                {
                    var wait = $( '#gateway-power-wait' );
                    wait.dialog(
                    {
                        closeOnEscape : false,
                        draggable : false,
                        resizable : false,
                        title : title,
                        modal : true,
                        open : function( event, ui )
                        {
                            $( ".ui-dialog-titlebar-close", $( this ).parent( ) ).hide( );
                        }
                    } );
                    var countdown = function( v )
                    {
                        if( v == 0 )
                        {
                            wait.dialog( 'destroy' );
                            $( '#refreshing' ).show( );
                            window.location.reload( );
                            return;
                        }
                        var b = '';
                        for( var i = 0; i < v; i++ )
                        {
                            b += '.';
                        }
                        $( '#gateway-power-wait .countdown' ).text( b );
                        setTimeout( countdown, 1000, v - 1 );
                    };
                    countdown( 30 );
                }
                else
                {
                    ShowNotice( data.message, false );
                }
            }
        } );
    }
}

// Gateway CDR configuration JS calls
function initCDR( )
{
    // drag options
    $( '.gateway-cdr-option' ).draggable(
    {
        containment : '#gateway-cdr',
        scroll : false,
        opacity : 0.7,
        helper : "clone"
    } );
    // insert option into pattern editor
    $( '.gateway-cdr-option' ).dblclick( function( )
    {
        $( '#gateway-cdr-pattern' ).insertText( "${" + $( this ).attr( 'cdr-value' ) + "}", $( '#gateway-cdr-pattern' ).getSelection( ).start, true );
    } );
    // option help tooltip
    $( '.gateway-tooltip' ).mouseover( function( event )
    {
        showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
    } );
    $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    // pattern editor, accept option drag and highlight on drag
    $( '#gateway-cdr-pattern' ).droppable(
    {
        accept : '.gateway-cdr-option',
        activeClass : 'gateway-cdr-data-highlight',
        greedy : true,
        drop : function( event, ui )
        {
            $( ui.draggable ).dblclick( );
        }
    } );
    // pattern editor should restrict the chr(13) (enter) key press
    $( '#gateway-cdr-pattern' ).keypress( function( evt )
    {
        if( evt.which == 13 )
        {
            evt.preventDefault( );
        }
    } );
    // save event, send needed data by POST ajax call
    $( '#gateway-cdr-save' ).click( function( )
    {
        disableButton( 'gateway-cdr-save' );
        $( '#refreshing' ).show( );

        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=saveCDROptions',
            data :
            {
                'Enabled' : $( '#gateway-cdr-enabled' ).is( ':checked' ),
                'Pattern' : $( '#gateway-cdr-pattern' ).val( ),
                'Rotate' : $( '#gateway-cdr-rotate :selected' ).val( )
            },
            dataType : "json",
            type : "POST",
            success : function( data )
            {
                ShowNotice( data.message, data.success );
                $( '#refreshing' ).hide( );
                enableButton( 'gateway-cdr-save' );
            },
            error : ajaxDefaultError
        } );
    } );
    // time format help
    $( '[class~="gateway-cdr-help-title"]' ).each( function( idx, elm )
    {
        $( elm ).collapser(
        {
            mode : 'block',
            target : 'next',
            effect : 'fade',
            changeText : 0
        }, function( )
        {
        }, function( )
        {
            var current_html = $( this ).html( );
            if( current_html[0] == "+" )
            {
                $( this ).html( current_html.replace( "+", "-" ) );
            }
            else
            {
                $( this ).html( current_html.replace( "-", "+" ) );
            }
        } );
    } );
    // sample copy event
    $( '[class~="gateway-cdr-help-sample-copy"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            $( '#gateway-cdr-pattern' ).val( $( this ).prev( ).text( ) );
        } );
    } );
    // enable/disable CDR
    $( '#gateway-cdr-enabled' ).change( function( ev )
    {
        var disabled = !$( this ).is( ':checked' );
        $( '#gateway-cdr-pattern' ).attr( 'disabled', disabled );
        $( '#gateway-cdr-rotate' ).attr( 'disabled', disabled );
    } ).change( );
}

// Gateway codec profile functions
function initCodecProfiles( )
{
    // (re)load codec profile list
    var loadCodecProfiles = function( )
    {
        changeView( 'showCodecProfiles', null, 'menu-routing-gw,menu-profiles-gw,menu-codec-profiles-gw' );
    };
    var saveCodecProfile = function( )
    {
        var codecList = [];
        var name = $.trim( $( '#gateway-codec-profile-name' ).val( ) );

        $( '[class~="gateway-codec-profile-list"]:checked' ).each( function( idx, elm )
        {
            codecList.push( $( elm ).val( ) );
        } );
        if( name.length == 0 )
        {
            ShowNotice( ajaxI18N( 'gateway-codec-profile-save-error-name-required' ), false );
            return;
        }
        else if( codecList.length == 0 )
        {
            ShowNotice( ajaxI18N( 'gateway-codec-profile-save-error-codec-required' ), false );
            return;
        }
        var oldName = $( '#gateway-codec-profile-old-name' ).val( );

        $( '#refreshing' ).show( );
        disableButton( 'gateway-codec-profile-save' );
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=saveCodecProfile',
            data :
            {
                'name' : name,
                'oldName' : oldName,
                'codecList' : codecList
            },
            dataType : 'json',
            type : 'POST',
            success : function( data )
            {
                ShowNotice( data.message, data.success );
                if( data.success )
                {
                    loadCodecProfiles( );
                }
                else
                {
                    enableButton( 'gateway-codec-profile-save' );
                }
            },
            error : ajaxDefaultError
        } );
    };
    formCodecProfile = function( text )
    {
        $( '#gateway-codec-profile-container' ).html( text );
        $( '#gateway-codec-profile-list-container' ).sortable(
        {
            revert : true
        } );
        $( '#gateway-codec-profile-list-container' ).disableSelection( );
        $( '#gateway-codec-profile-list-container' ).each( function( idx, elm )
        {
            $( elm ).disableSelection( );
        } );
        $( '#gateway-codec-profile-back' ).click( loadCodecProfiles );
        $( '#gateway-codec-profile-save' ).click( saveCodecProfile );
        // tooltips
        $( '.gateway-tooltip' ).mouseover( function( event )
        {
            showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
        $( '#gateway-codec-profile-select-all' ).click( function( ev )
        {
            $( '[class~="gateway-codec-profile-list"]' ).each( function( idx, elm )
            {
                $( elm ).attr( 'checked', true );
            } );
        } );
        $( '#gateway-codec-profile-select-none' ).click( function( ev )
        {
            $( '[class~="gateway-codec-profile-list"]' ).each( function( idx, elm )
            {
                $( elm ).attr( 'checked', false );
            } );
        } );
        $( '#refreshing' ).hide( );
    };
    // new codec profile button
    $( '#gateway-codec-profile-button-new' ).click( function( )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=addCodecProfile',
            dataType : 'html',
            type : 'POST',
            success : formCodecProfile,
            error : ajaxDefaultError
        } );
    } );
    // edit codec profile buttons
    $( '[class~="gateway-codec-profile-edit"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            var name = $( elm ).parent( ).parent( ).children( ).first( ).text( );
            $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=editCodecProfile',
                data :
                {
                    'name' : name
                },
                dataType : 'html',
                type : 'POST',
                success : formCodecProfile,
                error : ajaxDefaultError
            } );
        } );
    } );
    // delete codec profile buttons
    $( '[class~="gateway-codec-profile-delete"]' ).each( function( idx, elm )
    {
        $( elm ).click( function( )
        {
            if( ajaxConfirm( 'gateway-codec-profile-confirm-delete' ) )
            {
                var name = $( elm ).parent( ).parent( ).children( ).first( ).text( );
                $( '#refreshing' ).show( );
                $.kajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=deleteCodecProfile',
                    data :
                    {
                        'name' : name
                    },
                    dataType : 'json',
                    type : 'POST',
                    success : function( data )
                    {
                        ShowNotice( data.message, data.success );
                        if( data.success )
                        {
                            loadCodecProfiles( );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
            $( '#refreshing' ).hide( );
        } );
    } );
    // main table sorter
    $( '#gateway-codec-profile-table' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            2 :
            {
                sorter : false
            }
        },
        sortList : [[0, 0]]
    } );
}

// gateway routes
function initRoutesGW( )
{
    // (re)load routes table
    var loadRoutes = function( )
    {
        changeView( 'showRoutesGW', null, 'menu-routing-gw,menu-routes-gw' );
    };
    // attach route form events
    var initRouteForm = function( )
    {
        // attach events
        $( '#gateway-route-form-destination-nap' ).change( function( )
        {
            var _val = $( '#gateway-route-form-destination-nap' ).val( );
            _val = _val.slice( 0, _val.search( '>' ) );
            if( _val == 'SIP' )
            {
                $( '#gateway-route-form-codec-profile-list' ).show( );
            }
            else
            {
                $( '#gateway-route-form-codec-profile-list' ).hide( );
            }
        } ).change( );
        $( "#gateway-route-form-destination-service-providers" ).chosen( );
        $( '#gateway-route-form-destination-check-portability' ).change( function( )
        {
            if( $( this ).is( ":checked" ) )
            {
                $( '.gateway-route-form-destination-portability' ).show( );
            }
            else
            {
                $( '.gateway-route-form-destination-portability' ).hide( );
                $( '#gateway-route-form-destination-service-providers' ).children( ).removeAttr( "selected" ).trigger( "chosen:updated" );
            }
        } ).change( );
        // tooltips
        $( '.gateway-tooltip' ).mouseover( function( event )
        {
            showKhompChanToolTip( event, $( this ).attr( 'khelp' ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
        $( '#gateway-route-form-save' ).click( function( )
        {
            var mydata =
            {
            };

            $( '#refreshing' ).show( );
            try
            {
                // grab data
                $( '.gateway-table-form input[type~="text"]' ).each( function( )
                {
                    mydata[$( this ).attr( 'name' )] = $( this ).val( );
                } );
                $( '.gateway-table-form input[type~="hidden"]' ).each( function( )
                {
                    mydata[$( this ).attr( 'name' )] = $( this ).val( );
                } );
                $( '.gateway-table-form select:not([multiple])' ).each( function( )
                {
                    var _val = $( this ).val( );
                    if( _val.indexOf( '>' ) > -1 && _val.indexOf( '>' ) < (_val.length - 1) )
                    {
                        _val = _val.slice( _val.search( '>' ) + 1 );
                    }
                    mydata[$( this ).attr( 'name' )] = _val;
                } );
                $( '.gateway-table-form select[multiple]' ).each( function( )
                {
                    mydata[$( this ).attr( 'name' )] = $( this ).val( ) || [];
                } );

                // validation
                if( mydata['Name'] == '' )
                {
                    throw 'gateway-route-error-name-is-required';
                }
                if( mydata['OriginNAP'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-origin-nap-is-required';
                }
                if( $( '#gateway-route-form-destination-check-portability' ).is( ':checked' ) && mydata['DestinationServiceProvider'].length == 0 )
                {
                    throw 'gateway-route-error-at-least-one-destination-service-provider-is-required';
                }
                if( mydata['DestinationNAP'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-destination-nap-is-required';
                }
                var _val = $( '#gateway-route-form-destination-nap' ).val( );
                _val = _val.slice( 0, _val.search( '>' ) );
                if( _val == 'SIP' && mydata['CodecProfile'] == '<SELECT>' )
                {
                    throw 'gateway-route-error-codec-profile-is-required';
                }
                else if( _val != 'SIP' )
                {
                    // always blank codec profile if it is not SIP
                    mydata['CodecProfile'] = '';
                }
                if( mydata['DestinationProfile'] == '' )
                {
                    delete mydata['DestinationProfile'];
                }

                $.kajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=saveRouteGW',
                    data : mydata,
                    dataType : "json",
                    type : "POST",
                    success : function( data )
                    {
                        ShowNotice( data.message, data.success );
                        if( data.success )
                        {
                            loadRoutes( );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
            catch( e )
            {
                ShowNotice( ajaxI18N( e ), false );
            }
            $( '#refreshing' ).hide( );
        } );
        // back to list event
        $( '#gateway-route-form-back' ).click( loadRoutes );
        // Masked input
        $( '#gateway-route-form-priority' ).mask( '9?9', { placeholder: ' '} );
    };
    // add route
    var addRoute = function( )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=newRouteGW",
            dataType : "html",
            success : function( data )
            {
                $( '#gateway-route' ).html( data );
                initRouteForm( );
                $( '#refreshing' ).hide( );
            },
            error : ajaxDefaultError
        } );

    };
    // find route name inside main table
    var findRoute = function( elm )
    {
        return $( elm ).parent( ).parent( ).children( ).first( ).text( );
    };
    // edit route
    var editRoute = function( )
    {
        var name = findRoute( $( this ) );
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=editRouteGW",
            data :
            {
                name : name
            },
            dataType : "html",
            type : "POST",
            success : function( data )
            {
                $( '#gateway-route' ).html( data );
                initRouteForm( );
                $( '#refreshing' ).hide( );
            },
            error : ajaxDefaultError
        } );
    };
    // delete route
    var deleteRoute = function( )
    {
        if( ajaxConfirm( 'gateway-route-confirm-delete' ) )
        {
            var name = findRoute( $( this ) );
            $( '#refreshing' ).show( );
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=removeRouteGW",
                data :
                {
                    name : name
                },
                dataType : "json",
                type : "POST",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadRoutes( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };
    // main screen events
    // add/edit/delete buttons
    $( '.gateway-route-add' ).click( addRoute );
    $( '.gateway-route-edit' ).click( editRoute );
    $( '.gateway-route-delete' ).click( deleteRoute );
    // main table sorter
    $( '#gateway-route-list-table' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers:
        {
            1: { sorter: false },
            2: { sorter: false },
            3: { sorter: 'digit' },
            4: { sorter: false },
            6: { sorter: false },
            8: { sorter: false },
            9: { sorter: false },
        },
    } );

}

// initialize gateway profile
function initProfileGW( )
{
    var caActions = ['DROP', 'PLAYNDROP', 'NOTIFYNCONNECT'];
    var caEvents = ['OnHumanAnswer', 'OnAnsweringMachine', 'OnCellPhoneMessageBox', 'OnCarrierMessage', 'OnUnknown'];
    var cadences = ['Trying', 'Ringback'];

    // read profile name from table
    var getProfileName = function( elm )
    {
        // img (elm) -> td -> tr -> first td -> text
        return elm.parent( ).parent( ).children( ).first( ).text( );
    };
    // (re)load profile table
    var loadProfiles = function( )
    {
        changeView( 'showProfilesGW', null, 'menu-routing-gw,menu-profiles-gw,menu-profile-general-gw' );
    };
    var saveProfile = function( )
    {
        var getCadence = function( type )
        {
            var data = [];
            for( var i = 0; i < 4; i++ )
            {
                var x = $.trim( $( '#gateway-profile-cadence-' + type + '-' + i ).val( ) );
                if( x )
                {
                    data.push( x );
                }
            }
            if( data.length % 2 != 0 )
            {
                throw 'gateway-profile-error-invalid-cadence';
            }
            return data.join( ',' );
        };

        var getISDNValue = function( elm )
        {
            var tmp = parseInt( $( elm ).val( ), 10 );
            if( tmp < 1 || tmp > 127 )
            {
                throw 'gateway-cause-map-error-isdn-out-of-range';
            }
            return tmp;
        };

        var getR2Value = function( elm )
        {
            var tmp = parseInt( $( elm ).val( ), 10 );
            if( tmp < 0 || tmp > 8 )
            {
                throw 'gateway-cause-map-error-r2-out-of-range';
            }
            return tmp;
        };

        var getSIPValue = function( elm )
        {
            var tmp = parseInt( $( elm ).val( ), 10 );
            if( tmp < 200 || tmp > 699 )
            {
                throw 'gateway-cause-map-error-sip-out-of-range';
            }
            return tmp;
        };

        try
        {
            var mydata =
            {
                Name : $.trim( $( '#gateway-profile-name' ).val( ) ),
                __oldname__ : $( '#gateway-profile-oldname' ).val( ),
                EnableFeatures : [],
                DisableFeatures : [],
                FAX :
                {
                    Mode : $( '#gateway-profile-fax-mode' ).val( ),
                },
                R2 :
                {
                    DoubleAnswer :
                    {
                        Enabled : $( '#gateway-profile-r2-double-answer-enabled' ).is( ':checked' ),
                        Timeout : $.trim( $( '#gateway-profile-r2-double-answer-timeout' ).val( ) )
                    }
                },
                SIP :
                {
                    RelayExtensionHeaders : $( '#gateway-profile-sip-relay-extensions' ).is( ':checked' )
                },
                Cadences :
                {
                    Enabled : $( '#gateway-profile-cadences-enabled' ).is( ':checked' ),
                    Trying : '',
                    Ringback : ''
                },
                CauseMap : []
            };
            if( mydata['Name'] === '' )
            {
                throw 'gateway-profile-error-name-is-required';
            }
            $( '.gateway-profile-features' ).each( function( idx, elm )
            {
                if( $( elm ).is( ':checked' ) )
                {
                    mydata['EnableFeatures'].push( $( elm ).attr( 'name' ) );
                }
                else
                {
                    mydata['DisableFeatures'].push( $( elm ).attr( 'name' ) );
                }
            } );
            if( mydata['R2']['DoubleAnswer']['Enabled'] && mydata['R2']['DoubleAnswer']['Timeout'] === '' )
            {
                throw 'gateway-profile-error-invalid-r2-double-answer-timeout';
            }
            mydata['Cadences']['Trying'] = getCadence( 'Trying' );
            mydata['Cadences']['Ringback'] = getCadence( 'Ringback' );

            // has call analyzer
            if( $( '#gateway-profile-call-analyzer' ).length > 0 )
            {
                mydata['CallAnalyzer'] =
                {
                };
                mydata['CallAnalyzer']['Enabled'] = $( '#gateway-profile-call-analyzer-enabled' ).is( ':checked' );
                var getCallAnalyzerEvent = function( evt )
                {
                    var data =
                    {
                        Action : $( '#gateway-profile-call-analyzer-' + evt + '-Action' ).val( )
                    };
                    switch( data['Action'] )
                    {
                        case 'Connect':
                            break;
                        case 'PlayAndDrop':
                            data['AudioFile'] = $( '#gateway-profile-call-analyzer-' + evt + '-AudioFile' ).val( );
                            if( !data['AudioFile'] )
                            {
                                throw 'gateway-profile-error-select-audio-file';
                            }
                        /* no break */
                        case 'Drop':
                            data['DropBehavior'] = $( '#gateway-profile-call-analyzer-' + evt + '-DropBehavior' ).val( );
                            if( !data['DropBehavior'] )
                            {
                                throw 'gateway-profile-error-select-behavior';
                            }
                            break;
                        case 'NotifyAndConnect':
                            data['NotifyBehavior'] = $( '#gateway-profile-call-analyzer-' + evt + '-NotifyBehavior' ).val( );
                            if( !data['NotifyBehavior'] )
                            {
                                throw 'gateway-profile-error-select-behavior';
                            }
                            break;
                        default:
                            throw 'gateway-profile-error-invalid-call-analyzer-event-action';
                    }
                    return data;
                };

                var l = caEvents.length;
                for( var i = 0; i < l; i++ )
                {
                    mydata['CallAnalyzer'][caEvents[i]] = getCallAnalyzerEvent( caEvents[i] );
                }
            }

            $( 'tr[class~="gateway-profile-cause-map"]' ).each( function( idx, elm )
            {
                var tr = $( elm ).children( );
                mydata['CauseMap'].push(
                {
                    "Id" : parseInt( $( tr[0] ).children( ).first( ).val( ), 10 ),
                    "ISDN" : getISDNValue( $( tr[1] ).children( ).first( ) ),
                    "R2" : getR2Value( $( tr[2] ).children( ).first( ) ),
                    "SIP" : getSIPValue( $( tr[3] ).children( ).first( ) )
                } );
            } );
            
            /// Gain Control
            var gainControlFeature = $('#gateway-profile-feature-GainControl').val();
            if (gainControlFeature) {
                mydata['EnableFeatures'].push(( gainControlFeature === 'auto' ) ? 'AutoGainControl' : 'SetVolumeGain');
            }

            var manualGainControlValue = parseInt($('#gateway-profile-feature-VolumeGain').val(), 10);
            mydata['VolumeGain'] = ( manualGainControlValue && !isNaN(manualGainControlValue) ) ? manualGainControlValue : 0;

            $( "#refreshing" ).show( );

            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveProfileGW",
                dataType : "json",
                type : "POST",
                data : mydata,
                success : function( data )
                {
                    $( "#refreshing" ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadProfiles( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
        catch( e )
        {
            ShowNotice( ajaxI18N( e ), false );
        }
    };
    var initFormProfile = function( )
    {
        var x = $( '#gateway-profile-cadences-enabled' );
        x.change( function( )
        {
            var disabled = !$( this ).is( ':checked' );
            var l = cadences.length;
            for( var i = 0; i < l; i++ )
            {
                for( var k = 0; k < 4; k++ )
                {
                    $( '#gateway-profile-cadence-' + cadences[i] + '-' + k ).attr( 'disabled', disabled );
                }
            }
        } );
        x.change( );
        x = $( '#gateway-profile-r2-double-answer-enabled' ).change( function( )
        {
            $( '#gateway-profile-r2-double-answer-timeout' ).attr( 'disabled', !$( this ).is( ':checked' ) );

        } );
        x.change( );
        x = $( '#gateway-profile-call-analyzer' );
        if( x )
        {
            var checkbox = $( '#gateway-profile-call-analyzer-enabled' );
            checkbox.change( function( )
            {
                var disabled = !$( this ).is( ':checked' );
                var s = caEvents.length;
                for( var i = 0; i < s; i++ )
                {
                    var k = '#gateway-profile-call-analyzer-' + caEvents[i];
                    var ev = $( k );
                    if( ev )
                    {
                        var sel = $( k + '-Action' );

                        if( !('kinitialized' in sel ) )
                        {
                            sel.change( function( )
                            {
                                var k = $( this ).attr( 'id' );
                                k = k.split( '-' );
                                k.pop( );
                                k = "#" + k.join( '-' );

                                switch( $( this ).val() )
                                {
                                    case 'PlayAndDrop':
                                        $( k + '-PlayAndDrop' ).show( );
                                        $( k + '-Drop' ).show( );
                                        $( k + '-NotifyAndConnect' ).hide( );
                                        break;
                                    case 'Drop':
                                        $( k + '-PlayAndDrop' ).hide( );
                                        $( k + '-Drop' ).show( );
                                        $( k + '-NotifyAndConnect' ).hide( );
                                        break;
                                    case 'NotifyAndConnect':
                                        $( k + '-PlayAndDrop' ).hide( );
                                        $( k + '-Drop' ).hide( );
                                        $( k + '-NotifyAndConnect' ).show( );
                                        break;
                                    case 'Connect':
                                        $( k + '-PlayAndDrop' ).hide( );
                                        $( k + '-Drop' ).hide( );
                                        $( k + '-NotifyAndConnect' ).hide( );
                                        break;
                                    default:
                                        throw 'gateway-profile-error-invalid-call-analyzer-event-action';
                                        break;
                                }
                                $( this ).attr( 'disabled', disabled );
                                $( k + '-AudioFile' ).attr( 'disabled', disabled );
                                $( k + '-DropBehavior' ).attr( 'disabled', disabled );
                                $( k + '-NotifyBehavior' ).attr( 'disabled', disabled );
                            } );
                            sel.kinitialized = true;
                        }
                        sel.change( );
                    }
                }
            } );
            checkbox.change( );
        }
        
        /// Recursos

        /// GainControl
        $( '#gateway-profile-feature-GainControl' )
        .on('change.showvolumecontrol', function() {
            var disabled = ( $(this).val() !== 'manual' ) ? true : false;
            $( '#gateway-profile-feature-VolumeGain' )
            .prop( 'disabled', disabled )
            .css('visibility', (disabled) ? 'hidden' : 'visible');
        })
        .trigger('change.showvolumecontrol');

        $( '#gateway-profile-feature-VolumeGain' )
          .KInputvalidate()
          .KVolumeSlider();
        
        $( 'input[class~="gateway-profile-cause-map-input"]' ).each( function( idx, elm )
        {
            $( elm ).mask( '9?99' );
        } );
        $( '#gateway-profile-show-hide-cause-map' ).click( function( evt )
        {
            var _table = $( '#gateway-profile-cause-map-table' );
            if( _table.is( ":visible" ) )
            {
                $( this ).text( "+" + $( this ).text( ).slice( 1 ) );
            }
            else
            {
                $( this ).text( "-" + $( this ).text( ).slice( 1 ) );
            }
            _table.toggle( );
        } );

        $( '#gateway-profile-save' ).click( saveProfile );
        $( '#gateway-profile-back' ).click( loadProfiles );
        $( '#gateway-profile-r2-double-answer-timeout' ).mask( '9?9999' );
        $( '.gateway-profile-cadence-input' ).mask( '9?999' );
        // option help tooltip
        $( '.gateway-tooltip' ).mouseover( function( evt )
        {
            showKhompChanToolTip( evt, ajaxI18N( $( this ).attr( 'khelp' ) ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    };
    var addProfile = function( )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=formProfileGW",
            dataType : "html",
            success : function( data )
            {
                $( '#gateway-profile-fs .gateway-profile' ).html( data );
                initFormProfile( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var editProfile = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
            name : getProfileName( $( this ) )
        };
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=formProfileGW',
            dataType : "html",
            type : "POST",
            data : mydata,
            success : function( data )
            {
                $( '#gateway-profile-fs .gateway-profile' ).html( data );
                initFormProfile( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var copyProfile = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
            name : getProfileName( $( this ) ),
            copy : true
        };
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=formProfileGW',
            dataType : "html",
            type : "POST",
            data : mydata,
            success : function( data )
            {
                $( '#gateway-profile-fs .gateway-profile' ).html( data );
                initFormProfile( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var deleteProfile = function( )
    {
        if( confirm( ajaxI18N( 'gateway-profile-delete-confirm' ) ) )
        {
            $( '#refreshing' ).show( );
            var mydata =
            {
                name : getProfileName( $( this ) )
            };
            $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=deleteProfileGW',
                dataType : "json",
                type : "POST",
                data : mydata,
                success : function( data )
                {
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadProfiles( );
                    }
                },
                error : ajaxDefaultError
            } );
            $( '#refreshing' ).hide( );
        }
    };
    var setDefaultProfile = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
            name : getProfileName( $( this ) )
        };
        $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=setDefaultProfileGW',
            dataType : "json",
            type : "POST",
            data : mydata,
            success : function( data )
            {
                ShowNotice( data.message, data.success );
                if( data.success )
                {
                    loadProfiles( );
                }
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };

    // add/edit/delete buttons
    $( '.gateway-profile-add' ).click( addProfile );
    $( '.gateway-profile-edit' ).click( editProfile );
    $( '.gateway-profile-copy' ).click( copyProfile );
    $( '.gateway-profile-delete' ).click( deleteProfile );
    $( '.gateway-profile-set-as-default' ).click( setDefaultProfile );
}

// initialize gateway profile drop behaviors
function initProfileDropBehaviorGW( )
{
    // read behavior name from table
    var getBehaviorName = function( elm )
    {
        // img (elm) -> td -> tr -> first td -> text
        return elm.parent( ).parent( ).children( ).first( ).text( );
    };
    // (re)load behaviors main table
    var loadBehaviors = function( )
    {
        changeView( 'showDropBehaviorGW', null, 'menu-routing-gw,menu-profiles-gw,menu-profile-behaviors-gw,menu-profile-behavior-drop-gw' );
    };
    // deleted any behavior
    var deleteBehaviorSuccess = function( data )
    {
        ShowNotice( data.message, data.success );
        if( data.success )
        {
            loadBehaviors( );
        }
    };
    var saveDropBehavior = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
        };
        $( '.gateway-table-form input' ).each( function( )
        {
            var _v = $.trim( $( this ).val( ) );
            if( _v != '' )
            {
                mydata[ $( this ).attr( 'name' )] = _v;
            }
        } );
        try
        {
            if( !('Name' in mydata) )
            {
                throw 'gateway-profile-error-behavior-name-is-required';
            }
            if( !('SIPCode' in mydata) && !('SIPHeader' in mydata) && !('ISDNCause' in mydata) )
            {
                throw 'gateway-profile-error-behavior-not-configured';
            }
            if( ('SIPCode' in mydata) )
            {
                sipcode = parseInt( mydata['SIPCode'] );
                if( isNaN( sipcode ) || sipcode < 300 || sipcode > 699 )
                {
                    throw 'gateway-profile-error-behavior-sipcode-out-of-range';
                }
            }
            if( ('ISDNCause' in mydata) )
            {
                isdncause = parseInt( mydata['ISDNCause'] );
                // 133 -- kq931cNetworkRestart
                if( isNaN( isdncause ) || isdncause > 133 || isdncause < 0 )
                {
                    throw 'gateway-profile-error-behavior-isdncause-out-of-range';
                }
            }
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveDropBehaviorGW",
                dataType : "json",
                type : "POST",
                data : mydata,
                success : function( data )
                {
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadBehaviors( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
        catch( e )
        {
            ShowNotice( ajaxI18N( e ), false );
        }
        $( '#refreshing' ).hide( );
    };
    var initDropBehaviorForm = function( )
    {
        $( '#gateway-profile-behavior-SIPCode' ).mask( '9?99' );
        $( '#gateway-profile-behavior-ISDNCause' ).mask( '9?99' );
        $( '#gateway-profile-behavior-save' ).click( saveDropBehavior );
        $( '#gateway-profile-behavior-back' ).click( loadBehaviors );
        // option help tooltip
        $( '.gateway-tooltip' ).mouseover( function( evt )
        {
            showKhompChanToolTip( evt, ajaxI18N( $( this ).attr( 'khelp' ) ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    };
    var addDropBehavior = function( )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=formDropBehaviorGW",
            dataType : "html",
            success : function( data )
            {
                $( '#formulario .gateway-profile-drop-behavior' ).html( data );
                initDropBehaviorForm( );
                $( '#gateway-profile-notify-behavior' ).hide( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var editDropBehavior = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
            name : getBehaviorName( $( this ) )
        };
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=formDropBehaviorGW",
            dataType : "html",
            type : "POST",
            data : mydata,
            success : function( data )
            {
                $( '#formulario .gateway-profile-drop-behavior' ).html( data );
                initDropBehaviorForm( );
                $( '#gateway-profile-notify-behavior' ).hide( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var deleteDropBehavior = function( )
    {
        var mydata =
        {
            name : getBehaviorName( $( this ) )
        };
        if( confirm( ajaxI18N( 'gateway-profile-behavior-delete-confirm' ) ) )
        {
            $( '#refreshing' ).show( );
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=deleteDropBehaviorGW",
                dataType : "json",
                type : "POST",
                data : mydata,
                success : deleteBehaviorSuccess,
                error : ajaxDefaultError
            } );
            $( '#refreshing' ).hide( );
        }
    };

    // add/edit/delete buttons
    $( '.gateway-profile-add-drop-behavior' ).click( addDropBehavior );
    $( '.gateway-profile-edit-drop-behavior' ).click( editDropBehavior );
    $( '.gateway-profile-delete-drop-behavior' ).click( deleteDropBehavior );
}

// initialize gateway profile notify behaviors
function initProfileNotifyBehaviorGW( )
{
    // read behavior name from table
    var getBehaviorName = function( elm )
    {
        // img (elm) -> td -> tr -> first td -> text
        return elm.parent( ).parent( ).children( ).first( ).text( );
    };
    // (re)load behaviors main table
    var loadBehaviors = function( )
    {
        changeView( 'showNotifyBehaviorGW', null, 'menu-routing-gw,menu-profiles-gw,menu-profile-behaviors-gw,menu-profile-behavior-notify-gw' );
    };
    // deleted any behavior
    var deleteBehaviorSuccess = function( data )
    {
        ShowNotice( data.message, data.success );
        if( data.success )
        {
            loadBehaviors( );
        }
    };
    var saveNotifyBehavior = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
        };
        $( '.gateway-table-form input' ).each( function( )
        {
            var _v = $.trim( $( this ).val( ) );
            if( _v != '' )
            {
                mydata[ $( this ).attr( 'name' )] = _v;
            }
        } );
        try
        {
            if( !('Name' in mydata) )
            {
                throw 'gateway-profile-error-behavior-name-is-required';
            }
            if( !('SIPHeader' in mydata) )
            {
                throw 'gateway-profile-error-behavior-sipheader-is-required';
            }
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=saveNotifyBehaviorGW",
                dataType : "json",
                type : "POST",
                data : mydata,
                success : function( data )
                {
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        loadBehaviors( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
        catch( e )
        {
            ShowNotice( ajaxI18N( e ), false );
        }
        $( '#refreshing' ).hide( );
    };
    var initNotifyBehaviorForm = function( )
    {
        $( '#gateway-profile-behavior-save' ).click( saveNotifyBehavior );
        $( '#gateway-profile-behavior-back' ).click( function( )
        {
            loadBehaviors( );
        } );
        // option help tooltip
        $( '.gateway-tooltip' ).mouseover( function( evt )
        {
            showKhompChanToolTip( evt, ajaxI18N( $( this ).attr( 'khelp' ) ) );
        } );
        $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    };
    var addNotifyBehavior = function( )
    {
        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=formNotifyBehaviorGW",
            dataType : "html",
            success : function( data )
            {
                $( '#formulario .gateway-profile-notify-behavior' ).html( data );
                initNotifyBehaviorForm( );
                $( '#gateway-profile-drop-behavior' ).hide( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var editNotifyBehavior = function( )
    {
        $( '#refreshing' ).show( );
        var mydata =
        {
            name : getBehaviorName( $( this ) )
        };
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=formNotifyBehaviorGW",
            dataType : "html",
            type : "POST",
            data : mydata,
            success : function( data )
            {
                $( '#formulario .gateway-profile-notify-behavior' ).html( data );
                initNotifyBehaviorForm( );
                $( '#gateway-profile-drop-behavior' ).hide( );
            },
            error : ajaxDefaultError
        } );
        $( '#refreshing' ).hide( );
    };
    var deleteNotifyBehavior = function( )
    {
        var mydata =
        {
            name : getBehaviorName( $( this ) )
        };
        if( confirm( ajaxI18N( 'gateway-profile-behavior-delete-confirm' ) ) )
        {
            $( '#refreshing' ).show( );
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=deleteNotifyBehaviorGW",
                dataType : "json",
                type : "POST",
                data : mydata,
                success : deleteBehaviorSuccess,
                error : ajaxDefaultError
            } );
            $( '#refreshing' ).hide( );
        }
    };

    // add/edit/delete buttons
    $( '.gateway-profile-add-notify-behavior' ).click( addNotifyBehavior );
    $( '.gateway-profile-edit-notify-behavior' ).click( editNotifyBehavior );
    $( '.gateway-profile-delete-notify-behavior' ).click( deleteNotifyBehavior );
}

// initialize the license manager inside admin
function initLicenseManager( )
{
    $( '.license-manager-row' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            var id = '#license-manager-row-' + $.trim( $( this ).children( ).first( ).text( ) );
            $( id ).toggle( );
        } );
    } );
    $( '.license-manager-download' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            window.open( GLOBALAjaxURL + '&location=downloadLicense&name=' + $( this ).attr( 'name' ) );
            ev.stopPropagation( );
        } );
    } );
    $( '.license-manager-delete' ).each( function( idx, elm )
    {
        $( elm ).click( function( ev )
        {
            if( ajaxConfirm( 'license-manager-delete-confirm' ) )
            {
                var _img = $( this );
                $.kajax(
                {
                    url : GLOBALAjaxURL + '&ajaxTo=deleteLicense',
                    data :
                    {
                        'name' : $( this ).attr( 'name' )
                    },
                    dataType : 'json',
                    type : 'POST',
                    success : function( data )
                    {
                        $( '#refreshing' ).hide( );
                        if( data.success )
                        {
                            //TODO: reload license table
                            _img.parent( ).parent( ).next( ).remove( );
                            _img.parent( ).parent( ).remove( );
                            ShowNotice( data.message, true );
                        }
                        else
                        {
                            ShowNotice( data.message, false );
                        }
                    },
                    error : ajaxDefaultError
                } );
            }
            ev.stopPropagation( );
        } );
    } );
    $( '#license-manager-upload' ).ajaxForm(
    {
        dataType : 'json',
        beforeSend : function( )
        {
            disableButton( 'license-manager-upload input[type="submit"]' );
            var _submit = $( '#license-manager-upload input[type="submit"]' );
            _submit.prop( 'disabled', true );
            $( '#refreshing' ).show( );
        },
        complete : function( )
        {
            var _submit = $( '#license-manager-upload input[type="submit"]' );
            _submit.prop( 'disabled', false );
            enableButton( 'license-manager-upload input[type="submit"]' );
        },
        success : function( data )
        {
            $( '#refreshing' ).hide( );
            if( data.success )
            {
                ShowNotice( data.message, true );
                //TODO: reload license table
                window.location.reload( );
            }
            else
            {
                ShowNotice( data.message, false );
            }
        }
    } );
}

function initAuditGW( )
{
    // get route name from checkbox table
    var getAuditRouteName = function( elm )
    {
        return $( elm ).parent( ).next( ).text( );
    };
    var auditAjaxSuccess = function( data )
    {
        ShowNotice( data.message, data.success );
        changeView( 'showAuditGW', null, 'menu-routing-gw,menu-audit-gw' );
    };
    //@formatter:off
    /*
    $( "#gateway-audit-enable" ).change( function( ev )
    {
        var disabled = !$( this ).is( ':checked' );
        $( "#gateway-audit-start" ).prop( 'disabled', disabled );
        $( "#gateway-audit-end" ).prop( 'disabled', disabled );
        $( ".gateway-audit-route" ).each( function( idx, elm )
        {
            $( elm ).prop( 'disabled', disabled );
        } );
    } );
    $( "#gateway-audit-start" ).mask( "99/99/9999 99:99" );
    $( "#gateway-audit-start-now" ).click( function( ev )
    {
        var now = new Date( );
        var mynumberformat = function( number, size )
        {
            var tmp = new String( number );
            if( tmp.length < size )
            {
                tmp = new Array( ( size - tmp.length ) + 1 ).join( "0" ) + tmp;
            }
            return tmp;
        };

        //formatter:off
        $( "#gateway-audit-start" ).val(
            mynumberformat( now.getDay(), 2 )
            + "/"
            + mynumberformat( now.getMonth() + 1, 2 )
            + "/"
            + mynumberformat( now.getFullYear(), 4 )
            + " "
            + mynumberformat( now.getHours(), 2 )
            + ":"
            + mynumberformat( now.getMinutes(), 2 )
        );
        //formatter:on
    } );
    */
    //@formatter:on
    // load/unload tooltips
    $( '.gateway-tooltip' ).mouseover( function( event )
    {
        showKhompChanToolTip( event, ajaxI18N( $( this ).attr( 'id' ) ) );
    } );
    $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
    // select and remove all routes
    $( '#gateway-audit-select-all-routes' ).click( function( evt )
    {
        $( ".gateway-audit-route" ).each( function( idx, elm )
        {
            $( elm ).attr( 'checked', true );
        } );
    } );
    $( '#gateway-audit-remove-all-routes' ).click( function( evt )
    {
        $( ".gateway-audit-route" ).each( function( idx, elm )
        {
            $( elm ).attr( 'checked', false );
        } );
    } );
    // route table sorting
    $( '#gateway-audit-routes' ).tablesorter(
    {
        cssAsc : 'tablesorter-asc',
        cssDesc : 'tablesorter-desc',
        cssHeader : 'tablesorter-undefined',
        headers :
        {
            0 :
            {
                sorter : false
            }
        },
        sortList : [[1, 0]]
    } );
    // enable button
    $( '#gateway-audit-enable' ).click( function( ev )
    {
        var mydata =
        {
            End : $( '#gateway-audit-end' ).val( ),
            WholeCall : $( '#gateway-audit-whole-call' ).is( ':checked' ),
            Routes : []
        };
        try
        {
            $( '#gateway-audit-routes input[class~="gateway-audit-route"]:checked' ).each( function( idx, elm )
            {
                mydata.Routes.push( getAuditRouteName( elm ) );
            } );
            if( mydata.Routes.length == 0 )
            {
                throw 'gateway-audit-error-no-route-selected';
            }
            $( '#refreshing' ).show( );
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=enableAuditGW",
                data : mydata,
                dataType : 'json',
                type : 'POST',
                success : auditAjaxSuccess,
                error : ajaxDefaultError
            } );
        }
        catch( e )
        {
            ShowNotice( ajaxI18N( e ), false );
        }
        $( '#refreshing' ).hide( );
    } );
    // disable button
    $( '#gateway-audit-disable' ).click( function( ev )
    {
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=disableAuditGW",
            dataType : 'json',
            type : 'POST',
            success : auditAjaxSuccess,
            error : ajaxDefaultError
        } );
    } );
    // enable/disable fields
    //$( "#gateway-audit-enable" ).change( );
}

function initPortabilityGW( )
{
    //@formatter:off
    I18NReadToCache( [
        "cancel",
        "gateway-portability-driver-DISABLED",
        "gateway-portability-driver-LOCAL-DATABASE",
        "gateway-portability-local-summary-source-name-ServiceProvider",
        "gateway-portability-local-summary-source-name-Number",
        "gateway-portability-local-summary-source-name-NumberPrefix",
        "gateway-portability-local-summary-last-update-never",
        "gateway-portability-local-import",
        "gateway-portability-local-import-start",
        "gateway-portability-local-CSV-column"
    ], false );
    //@formatter:on

    var RunLocalPortabilityInterface = function( )
    {
        if( $( "#gateway-portability-local-CSV-column" ).length == 0 )
        {
            var columnstr = ajaxI18N( "gateway-portability-local-CSV-column" );
            $( '<style id="gateway-portability-local-CSV-column">#gateway-portability-local-import ol > li.i18n:before { content: "' + columnstr + ' #" counter(li-counter, decimal); }</style>' ).appendTo( 'head' );
        }

        var RenderPortabilitySummary = function( err, data )
        {
            if( err )
            {
                ShowNotice( err['message'], false );
                return;
            }

            var $tbody = $( "#gateway-portability-local-summary tbody" );
            $.each( data, function( idx, val )
            {
                var name = ajaxI18N( "gateway-portability-local-summary-source-name-" + val.Name );
                var ludate = new Date( val.LastUpdate * 1000 );
                var lastupdate = val.LastUpdate == 0 ? ajaxI18N( 'gateway-portability-local-summary-last-update-never' ) : ludate.toLocaleString( );
                var row = $( "<tr><td>" + name + "</td><td>" + val.RowCount + "</td><td>" + lastupdate + "</td></tr>" );
                $tbody.append( row );
            } );
        };

        var NewField = function( )
        {
            var _field = $( "#gateway-portability-local-import-field-format-tpl" ).clone( );
            var $fmt = $( "#gateway-portability-local-import-field-format ol" );
            _field.removeAttr( "id" ).attr( "name", "gateway-portability-local-import-fields[]" ).addClass( "gateway-portability-local-import-field" ).removeClass( "displayNone" ).change( function( evt )
            {
                if( $( this ).val( ).trim( ) == "" && $fmt.children( ).length > 1 )
                {
                    $( this ).parent( ).remove( );
                }
                else
                {
                    if( $fmt.children( ).last( ).children( ).first( ) == $( this ) || $fmt.children( ).last( ).children( ).first( ).val( ).trim( ) != "" )
                    {
                        NewField( );
                    }
                    if( $( this ).val( ).trim( ) == "OPERATION" )
                    {
                        $( "#gateway-portability-local-import-incremental" ).attr( "checked", true );
                    }
                }
            } );
            _field.show( );
            $li = $( "<li class='i18n'>" );
            $li.append( _field );
            $fmt.append( $li );
        };

        var ChangeType = function( )
        {
            var $this = $( this );
            $( "#gateway-portability-local-import-field-format select" ).each( function( idx, elm )
            {
                $elm = $( elm );
                switch( $this.val() )
                {
                    case "import-service-providers":
                        $elm.children( ).each( function( idx2, elm2 )
                        {
                            var $elm2 = $( elm2 );
                            if( $elm2.val( ) == "NUMBER" )
                            {
                                $elm2.attr( "disabled", "disabled" );
                                if( $elm.val( ) == $elm2.val( ) )
                                {
                                    $elm.val( "" );
                                    $elm.change( );
                                }
                            }
                            else if( $( elm2 ).val( ) == "SERVICEPROVIDER" )
                            {
                                $elm2.removeAttr( "disabled" );
                            }
                        } );
                        break;
                    case "import-numbers":
                    case "import-prefixes":
                        $elm.children( ).each( function( idx2, elm2 )
                        {
                            var $elm2 = $( elm2 );
                            if( $elm2.val( ) == "NUMBER" )
                            {
                                $elm2.removeAttr( "disabled" );
                            }
                            else if( $elm2.val( ) == "SERVICEPROVIDER" )
                            {
                                $elm2.attr( "disabled", "disabled" );
                                if( $elm.val( ) == $elm2.val( ) )
                                {
                                    $elm.val( "" );
                                    $elm.change( );
                                }
                            }
                        } );
                        break;
                }
            } );
        };

        var SanityCheck = function( )
        {
            var $modal = $( "#gateway-portability-local-import-form-div" );
            if( $modal.length > 0 )
            {
                $modal.dialog( "destroy" );
                $modal.remove( );
            }
        };

        var ImportData = function( )
        {
            var getValue = function( elm )
            {
                return $( elm ).val( ).trim( );
            };
            var isSet = function( elm )
            {
                return $( elm ).is( ":checked" ) || $( elm ).is( ":selected" );
            };

            var fmt = [];
            $( "#gateway-portability-local-import-field-format-list select" ).each( function( idx, elm )
            {
                var val = getValue( elm );
                if( val )
                {
                    fmt.push( val );
                }
            } );

            var data = [];
            var addData = function( name, value )
            {
                data.push(
                {
                    name : name,
                    value : value
                } );
            };

            addData( "Type", getValue( "#gateway-portability-local-import-type" ) );
            addData( "FieldDelimiter", getValue( "#gateway-portability-local-import-field-delimiter" ) );
            addData( "FieldClosure", getValue( "#gateway-portability-local-import-field-closure" ) );
            addData( "IgnoreFirstLine", isSet( "#gateway-portability-local-import-ignore-first-line" ) );
            addData( "Incremental", isSet( "#gateway-portability-local-import-incremental" ) );
            addData( "IgnoreErrors", isSet( "#gateway-portability-local-import-ignore-invalid" ) );
            addData( "Format", fmt );

            return data;
        };

        $( "#gateway-portability-options" ).empty( );
        $( '#refreshing' ).show( );
        // assert that the current portability driver is local database, if not
        // request configuration reload
        kgatewayrpc.PortabilityDriver( ).then( function( err, data )
        {
            if( err )
            {
                ShowNotice( err['message'], false );
                return;
            }
            else if( data != "LOCAL-DATABASE" )
            {
                $( "#gateway-portability-options" ).html( ajaxI18N( 'gateway-portability-need-configuration-reload' ) ).show( );
                $( '#refreshing' ).hide( );
                return;
            }
            $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=showLocalPortabilityGW",
                dataType : "html",
                type : "GET",
                success : function( data )
                {
                    var mydata = undefined;
                    SanityCheck( );
                    $( "#gateway-portability-options" ).append( $( data ) );
                    $( '.gateway-tooltip' ).mouseover( function( event )
                    {
                        showKhompChanToolTip( event, ajaxI18N( $( this ).attr( 'khelp' ) ) );
                    } );
                    $( '.gateway-tooltip' ).mouseout( hideKhompChanToolTip );
                    $( "#gateway-portability-local-import-type" ).change( ChangeType ).change( );
                    NewField( );
                    kgatewayrpc.PortabilitySummary( ).then( RenderPortabilitySummary );
                    $( "#gateway-portability-local-import-file" ).fileupload(
                    {
                        url : GLOBALAjaxURL + "?rawmode=yes&ajaxTo=importPortabilityFileGW",
                        dataType : "json",
                        replaceFileInput : false,
                        autoUpload : false,
                        acceptFileTypes : /(\.|\/)(txt|csv|gz)$/i,
                        maxNumberOfFiles : 1,
                        formData : ImportData,
                        add : function( e, data )
                        {
                            mydata = data;
                            var toHumanSize = function( val )
                            {
                                if( val < 1024 )
                                {
                                    return val + " B";
                                }
                                else if( val < (1024 * 1024) )
                                {
                                    return (val / 1024).toFixed( 2 ) + " KiB";
                                }
                                else if( val < (1024 * 1024 * 1024) )
                                {
                                    return (val / (1024 * 1024)).toFixed( 2 ) + "MiB";
                                }
                                else
                                {
                                    return (val / (1024 * 1024 * 1024)).toFixed( 2 ) + "GiB";
                                }
                            };
                            $( "#gateway-portability-local-import-file-info" ).text( toHumanSize( data.files[0].size ) );
                        },
                        start : function( e, data )
                        {
                            $( '#refreshing' ).show( );
                            $( "#gateway-portability-local-import-form-div" ).parent( ).find( ".ui-button" ).prop( 'disabled', true );
                            $( '#gateway-portability-local-import' ).hide( );
                            $( '#gateway-portability-local-import-progress' ).show( );
                            $( '#gateway-portability-local-import-progress-bar' ).progressbar(
                            {
                                value : false,
                                change : function( )
                                {
                                    $( this ).find( '.progress-label' ).text( $( this ).progressbar( "value" ) + "%" );
                                }
                            } );
                        },
                        done : function( e, data )
                        {
                            $( '#refreshing' ).hide( );
                            $( "#gateway-portability-local-import-form-div" ).parent( ).find( ".ui-button" ).prop( 'disabled', false );
                            $( '#gateway-portability-local-import-progress' ).hide( );
                            $( '#gateway-portability-local-import' ).show( );
                            ShowNotice( data.result.message, data.result.success );
                            if( data.result.success )
                            {
                                $( "#gateway-portability-local-import-form-div" ).dialog( "close" );
                            }
                        },
                        fail : function( e, data )
                        {
                            $( '#refreshing' ).hide( );
                            $( "#gateway-portability-local-import-form-div" ).parent( ).find( ".ui-button" ).prop( 'disabled', false );
                            $( '#gateway-portability-local-import-progress' ).hide( );
                            $( '#gateway-portability-local-import' ).show( );
                            ajaxDefaultError( data.jqXHR, data.textStatus, data.errorThrown );
                        },
                        progress : function( e, data )
                        {
                            var progress = parseInt( data.loaded / data.total * 100, 10 );
                            $( '#gateway-portability-local-import-progress-bar' ).progressbar( "value", progress );
                        }
                    } );
                    // lazy conversion from html entites to local charset
                    var btnstart = ( $( "<div />" ).html( ajaxI18N( 'gateway-portability-local-import-start' ) ).text( ) );
                    var btncancel = ajaxI18N( 'cancel' );
                    var _buttons =
                    {
                    };
                    _buttons[btnstart] = function( )
                    {
                        if( mydata == undefined )
                        {
                            ShowNotice( ajaxI18N( "gateway-portability-local-import-error-select-file" ), false );
                            return;
                        }
                        mydata.submit( );
                    };
                    _buttons[btncancel] = function( )
                    {
                        $( this ).dialog( "close" );
                    };
                    $( "#gateway-portability-local-import-form-div" ).dialog(
                    {
                        autoOpen : false,
                        closeOnEscape : true,
                        modal : true,
                        draggable : false,
                        resizable : false,
                        title : ajaxI18N( "gateway-portability-local-import" ),
                        width : $( window ).width( ) - 240,
                        height : $( window ).height( ) - 160,
                        buttons : _buttons
                    } );
                    $( '#gateway-portability-local-import-button' ).click( function( )
                    {
                        $( "#gateway-portability-local-import-form-div" ).dialog( "open" );
                    } );
                    $( "#gateway-portability-options" ).show( );
                    $( '#refreshing' ).hide( );
                },
                error : ajaxDefaultError
            } );
        } );
    };

    var Init = function( err, data )
    {
        if( err )
        {
            ShowNotice( err['message'], false );
            return;
        }

        var $select = $( "#gateway-portability-driver" );
        $.each( data, function( idx, val )
        {
            var buf = "<option value='" + val.Name + "'";
            if( val.Current )
                buf += " selected";
            buf += ">" + ajaxI18N( 'gateway-portability-driver-' + val.Name ) + "</option>";

            $select.append( buf );
        } );
        $select.change( function( )
        {
            switch( $(this).val() )
            {
                case "DISABLED":
                    $( "#gateway-portability-options" ).empty( );
                    $( "#gateway-portability-options" ).hide( );
                    break;
                case "LOCAL-DATABASE":
                    RunLocalPortabilityInterface( );
                    break;
            }
        } );
        $select.change( );
        // save button
        $( '#gateway-portability-save' ).click( function( )
        {
            $( '#refreshing' ).show( );
            var mydata =
            {
                Driver : $select.val( ),
                DriverOptions : ""
            };
            $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=savePortabilityGW',
                type : "POST",
                dataType : "json",
                data : mydata,
                success : function( data )
                {
                    ShowNotice( data.message, data.success );
                    $( '#refreshing' ).hide( );
                },
                error : ajaxDefaultError
            } );
        } );
    };

    kgatewayrpc.PortabilityDriversAvailable( ).then( Init );
}

var serviceProviders = {
    "72400" : "NEXTEL",
    "72402" : "TIM",
    "72403" : "TIM",
    "72404" : "TIM",
    "72405" : "CLARO",
    "72406" : "VIVO",
    "72410" : "VIVO",
    "72411" : "VIVO",
    "72415" : "CTBC",
    "72416" : "BRASIL TELECOM",
    "72423" : "VIVO",
    "72431" : "OI",
    "72432" : "CTBC",
    "72433" : "CTBC",
    "72434" : "CTBC",
    "72439" : "NEXTEL"
};

function SimCardToString( sim )
{
    var $span = $( "<span />" );

    $span.append( 'ICCID: ' + kgatewayFormatICCID( sim.ICCID ) );
    if( "IMSI" in sim && sim.IMSI )
        $span.append( ' - IMSI: ' + kgatewayFormatIMSI( sim.IMSI ) );

    if( "Device" in sim && sim.Device )
    {
        $span.append( ' - D' + sim.Device.Serial + ' C' + sim.Device.Channel + ' SIM ' + sim.Device.Index );
    }
    else
    {
        $span.append( " - unknown device" );
    }

    if( "IMSI" in sim && sim.IMSI.slice( 0, 5 ) in serviceProviders )
    {
        $span.append( " - " + serviceProviders[sim.IMSI.slice( 0, 5 ) ] );
    }

    return $span;
}

function SimCardList( $parent, selected, unavailable, configured )
{
    var appendToForm = function( $parent, sim, isChecked, isDisabled, sameNap )
    {
        var $label = $( '<label />' ).prop(
          {
            name : sim.ICCID,
            "for" : "SIMCARD-" + sim.ICCID
          }
        );
        if( !sim.Configured )
        {
            $label.append( kuiInlineIcon( "star", kuiInlineIconColors.blue, kuiInlineIconTextPosition.right, { title : ajaxI18NToLocaleCharset( 'gateway-gsm-sim-card-discovered' ) } ) );
        }
        if( isDisabled )
        {
            $label.addClass( "gateway-nap-fully-allocated" );
        }
        $label.append( SimCardToString( sim ) );
        if( !sameNap )
        {
            var attributes = {
                title : ajaxI18NToLocaleCharset( "gateway-nap-gsm-sim-cards-same-device-and-channel-different-nap" )
            };
            $label.append( kuiInlineIcon( 'alert', kuiInlineIconColors.red, kuiInlineIconTextPosition.left, attributes ) );
        }

        $parent
            .append( $('<input />')
                .prop({ 
                    name: sim.ICCID,
                    id : "SIMCARD-" + sim.ICCID,
                    type: 'checkbox', 
                    checked: isChecked,
                    disabled: isDisabled,
                    class: 'sim_card'
                })
            )
            .append( $label )
            .append( '<br />');
    };

    var appendIfNotThere = function( list, iccid )
    {
        var found = false;
        for( var i=0; i< list.length; ++i )
        {
            if( list[i].ICCID == iccid )
            {
                found = true;
                break;
            }
        }
        if( !found )
        {
            list.push( { ICCID: iccid, Configured: true } );
        }
    };

    var otherSimCardsAreOnTheSameNap = function( sim, allsims )
    {
        if( !sim.Device )
        {
            return true;
        }

        for( var other = 0; other < allsims.length; other++ )
        {
            //@formatter:off
            if(
                sim.ICCID == allsims[other].ICCID
                || !allsims[other].Device
                || !allsims[other].NAP
            )
            {
                continue;
            }
            if(
                sim.Device.Serial == allsims[other].Device.Serial
                && sim.Device.Channel == allsims[other].Device.Channel
                && sim.NAP != allsims[other].NAP 
            )
            {
                return false;
            }
            //@formatter:on
        }
        return true;
    };

    var addSimCardMannualy = function( event )
    {
        var uniqueId = "id-" + Math.floor(Math.random() * 10000);
        var $parent = event.data.parent;
        var FocusOut = function()
        {
            var $this = $(this);
            var iccid = $this.val().replace(/[_\-]/g, '' );

            var valid = true;
            if( iccid.length < 19 )
            {
                valid = false;
            }

            if( valid )
            {
                $( '.sim_card' ).each( function( idx, inputtext ) {
                    if( $( inputtext ).attr( 'name' ) == iccid )
                    {
                        valid = false;
                        return false; /* break $.each */
                    }
                } );
            }

            var $par = $('#' + uniqueId + '-label' );
            if( valid )
            {
                $par.prop( { 'for': iccid } );
                $('#' + uniqueId + '-checkbox').prop({name: iccid, disabled: false, checked:true}).addClass('sim_card'); 
                $this.remove();
                $par.append( kgatewayFormatICCID( iccid ) );
                $par.removeClass('gateway-nap-fully-allocated');
            }
            else
            {
                $this.addClass('has-error');
                $par.addClass('gateway-nap-fully-allocated');
            }
        };

        var $container = $('<span>')
            .prop( { id: uniqueId + '-container' } )
            .append( $('<input>')
                .prop( {
                    type: 'checkbox',
                    disabled: true,
                    id: uniqueId + '-checkbox'
                } )
                .click(
                    function( )
                    {
                        if( $( this ).is( ":checked" ) )
                        {
                            $( "#" + uniqueId + "-label" ).removeClass( "gateway-gsm-sim-card-deleted" );
                        }
                        else
                        {
                            $( "#" + uniqueId + "-label" ).addClass( "gateway-gsm-sim-card-deleted" );
                        }
                    }
                )
            )
            .append( $('<label>')
                .prop( {'for': uniqueId + "-checkbox", id: uniqueId + '-label'})
                .append( "ICCID: " )
                .append( $('<input>')
                    .prop({type: 'text', id: uniqueId + '-text'})
                    .mask('?99999-99999-99999-99999')
                    .addClass('wide')
                    .on( 'focusout', FocusOut )
                )
            )
            .append( '<br/>' ); 
        $parent.append( $container );
        $('#' + uniqueId+'-text').focus();
    };

    kgatewayrpc.GsmSimCards().then( function( err, data ) 
    {
        if( err )
        {
            ShowNotice( err['message'], false );
            return;
        }
        $.each( selected, function( idx ) { appendIfNotThere( data.SIMs, selected[idx] ); } );
        $.each( unavailable, function( idx ) { appendIfNotThere( data.SIMs, unavailable[idx] ); } );
        $.each( configured, function( idx, iccid ) { appendIfNotThere( data.SIMs, iccid ); } );
        $.each( data.SIMs, function( idx, val)
        {
            var isChecked = $.inArray( val.ICCID, selected ) != -1;
            var isUnavailable = $.inArray( val.ICCID, unavailable ) != -1;
            var sameNap = otherSimCardsAreOnTheSameNap( val, data.SIMs );

            appendToForm( $parent, val, isChecked, isUnavailable, sameNap );
        } );
        var $addMannualy = $("<input>")
            .prop( { 'type': 'button', 'value': ajaxI18N('gateway-nap-gsm-sim-cards-add-manually') } )
            .on( 'click', { parent: $parent }, addSimCardMannualy );
        $parent.parent().append( $addMannualy );
    } );
}

function initAllSimCardsAndItsNapsGW( )
{
    var simsConfigured = { };
    var $table = $( "#gateway-gsm-sim-cards-table tbody" );
    // destroy tablesorter plugin
    $table.parent().trigger( "destroy" );
    $table.children().remove();
    var newSimCard = 0;

    $.kajax(
    {
        url : GLOBALAjaxURL + "&ajaxTo=getConfiguredSimCards",
        type : "POST",
        dataType : "json",
        async : false,
        success : function( data )
        {
            simsConfigured = data;
        },
        error : ajaxDefaultError
    } );

    var readICCIDFromInput = function( jQueryObject )
    {
        var valid = true;
        var ICCID = jQueryObject.val().replace( /[_\-]/g, '' );
        if( ICCID.length < 19 )
        {
            valid = false;
        }

        if( valid )
        {
            $( '.gateway-gsm-sim-card' ).each( function( idx, inputtext ) {
                if( $( inputtext ).val() == ICCID )
                {
                    valid = false;
                    return false; /* break $.each */
                }
            } );
        }

        if( valid )
        {
            jQueryObject.removeClass( 'has-error' );
            return ICCID;
        }
        else
        {
            jQueryObject.addClass( 'has-error' );
            return null;
        }
    };

    var save = function( )
    {
        var mydata = {"SIMs" : []};
        $( ".gateway-gsm-sim-card" ).each( function( idx, elm ) {
            var sim = { };
            sim.ICCID = $( this ).val();
            var nap = $( "#nap-for-" + sim.ICCID ).val();
            sim.Number = $( "#number-for-" + sim.ICCID ).val();
            sim.NAP = nap.length ? nap : null;
            mydata.SIMs.push( sim );
        });

        $( '#refreshing' ).show( );
        $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=saveSimCards",
            type : "POST",
            dataType : "json",
            data : mydata,
            success : function( data )
            {
                $( '#refreshing' ).hide( );
                ShowNotice( data.message, data.success );
                if( data.success )
                {
                    initAllSimCardsAndItsNapsGW( );
                }
            },
            error : ajaxDefaultError
        } );
    };

    var createNumberInput = function( elm_id )
    {
        return $( "<input />" ).mask( "9?99999999999999" ).attr( { "id" : elm_id, "type" : "text" } );
    };

    var createSimCardHiddenInput = function( ICCID )
    {
        return $( "<input />" ).attr( { "type" : "hidden", "id" : "sim-" + ICCID } ).val( ICCID ).addClass( "gateway-gsm-sim-card" );
    };

    var addSimCard = function( )
    {
        var validate = function( elm )
        {
            var $this = $( this );
            var ICCID = readICCIDFromInput( $this );
            if( ICCID )
            {
                var $parent = $this.parent( );
                $( '#nap-for-new-sim-' + $this.attr( 'card-index' ) ).attr( { "id" : "nap-for-" + ICCID } );
                $( '#number-for-new-sim-' + $this.attr( 'card-index' ) ).attr( { "id" : "number-for-" + ICCID } );
                $parent.text( "" ).children().remove();
                //@formatter:off
                $parent
                  .append( $( "<label />" ).append( "ICCID: " + kgatewayFormatICCID( ICCID ) ).attr( { "for" : "nap-for-" + ICCID } ) )
                  .append( $( "<input />" ).attr( { "type" : "hidden", "id" : "sim-" + ICCID } ).val( ICCID ).addClass( "gateway-gsm-sim-card" ) );
                //@formatter:on
            }
        };

        var $select = $( "#gateway-gsm-sim-cards-nap-tpl" ).clone().attr( { "id" : "nap-for-new-sim-" + newSimCard } ).addClass( "gateway-gsm-sim-cards-config" ).change( changeNapCallback ).val( '' ).change( );
        var $iccidinput = $( "<input />" ).mask( "9?9999-99999-99999-99999" ).attr( { "id" : "new-sim-" + newSimCard, "card-index" : newSimCard, "type" : "text" } ).on( "focusout", validate ).addClass( "wide" );

        //@formatter:off
        $table.append(
          $( "<tr />" ).append(
            $( "<td />" ).append( "ICCID: " ).append( $iccidinput )
          ).append(
            $( "<td />" ).append( createNumberInput( "number-for-new-sim-" + newSimCard ) )
          ).append(
            $( "<td />" ).append( $select.show() )
          )
        );
        //@formatter:on
        $iccidinput.focus();
        newSimCard += 1;
    };

    var addDiscoveredSimCard = function( )
    {
        var $this = $( this );
        var ICCID = $this.attr( "ICCID" );
        var $row = $this.parent( ).parent( ).parent( );
        $row.children( ).first( ).append( createSimCardHiddenInput( ICCID ) );
        $row.find( "input" ).prop( { "disabled" : false } );
        var $select = $row.find( "select" ).prop( { "disabled" : false } ).change( );
        $this.remove();
    };

    var deleteSimCard = function( )
    {
        if( confirm( ajaxI18NToLocaleCharset( 'gateway-nap-gsm-sim-card-delete-confirm' ) ) )
        {
            // the input @ first TD of the row has the SIM card ICCID
            var iccid = $( this ).parent( ).parent( ).parent( ).children( ).first( ).find( "input" ).val( );

            $( "#refreshing" ).show();
            $.kajax( {
                url : GLOBALAjaxURL + "&ajaxTo=deleteSimCard",
                data : { "ICCID" : iccid },
                type : "POST",
                dataType : "json",
                success : function( data )
                {
                    $( '#refreshing' ).hide( );
                    ShowNotice( data.message, data.success );
                    if( data.success )
                    {
                        initAllSimCardsAndItsNapsGW( );
                    }
                },
                error : ajaxDefaultError
            } );
        }
    };

    var changeNapCallback = function()
    {
        if( $( this ).prop( "disabled" ) === false && $( this ).val() == "" ) // not assigned
        {
            $( this ).addClass( "gateway-nap-gsm-sim-card-select-not-assigned" );
        }
        else
        {
            $( this ).removeClass( "gateway-nap-gsm-sim-card-select-not-assigned" );
        }
    };

    kgatewayrpc.GsmSimCards().then( function( err, data )
    {
        if( err )
        {
            ShowNotice( err.message, false );
            return;
        }

        var enabledICCIDs = [ ];
        $( data.SIMs ).each( function( idx, sim )
        {
            var cfg = null;
            $( simsConfigured ).each( function( idx, mycfg ) {
                if( mycfg.ICCID === sim.ICCID )
                {
                    cfg = mycfg;
                    return false; // break
                }
            } );

            var $select = $( "#gateway-gsm-sim-cards-nap-tpl" ).clone().attr( { "id" : "nap-for-" + sim.ICCID } ).addClass( "gateway-gsm-sim-cards-config" ).change( changeNapCallback );
            if( cfg != null && cfg.NAP !== null )
            {
                $select.val( cfg.NAP );
            }

            // current configuration SIM cards
            //@formatter:off
            var $label = $( "<label />" ).append( SimCardToString( sim ) )
              .attr( {
                "for" : "nap-for-" + sim.ICCID
              } );
            var $numberinput = createNumberInput( "number-for-" + sim.ICCID ).val( cfg === null ? sim.Number : cfg.Number );
            var $options = $( "<span />" );
            var $iccidinput = "";

            if( cfg === null && sim.Configured )
            {
                $label.addClass( 'gateway-gsm-sim-card-deleted' );
                $numberinput.prop( { "disabled" : true } );
                $select.prop( { "disabled" : true } );
                $label.prepend( kuiInlineIcon( "close", kuiInlineIconColors.red, kuiInlineIconTextPosition.right, { title : ajaxI18NToLocaleCharset( 'gateway-need-configuration-reload' ) } ) );
            }
            else
            {
                if( cfg === null )
                {
                    //@formatter:off
                    cfg = {
                        "Number" : "",
                        "NAP" : ""
                    };
                    //@formatter:on
                    $numberinput.prop( { "disabled" : true } );
                    $select.prop( { "disabled" : true } );
                    $label.prepend( kuiInlineIcon( "star", kuiInlineIconColors.blue, kuiInlineIconTextPosition.right, { title : ajaxI18NToLocaleCharset( 'gateway-gsm-sim-card-discovered' ) } ) );
                    // add option
                    $options.append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/edit.png" } ).attr( { "ICCID" : sim.ICCID } ).on( "click", addDiscoveredSimCard ) );
                }
                else
                {
                    if(
                        ( cfg.Number != sim.Number )
                        || ( cfg.NAP != sim.NAP )
                    )
                    {
                        $label.prepend( kuiInlineIcon( "notice", kuiInlineIconColors.blue, kuiInlineIconTextPosition.right, { title : ajaxI18NToLocaleCharset( 'gateway-need-configuration-reload' ) } ) );
                    }

                    $iccidinput = $( "<input />" ).attr( { "type" : "hidden", "id" : "sim-" + sim.ICCID } ).val( sim.ICCID ).addClass( "gateway-gsm-sim-card" );
                    // delete option
                    $options.append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/remove.png" } ).on( "click", deleteSimCard ) );
                }
            }
            $select.change( );

            $table.append(
              $( "<tr />" ).append(
                $( "<td />" ).append( $label ).append( $iccidinput )
              ).append(
                $( "<td />" ).append( $numberinput )
              ).append(
                $( "<td />" ).append( $select.show() )
              ).append(
                $( "<td />" ).append( $options ).addClass( "gateway-table-options" )
              )
            );
            //@formatter:on
            enabledICCIDs.push( sim.ICCID );
        } );

        // configured but not enabled (configuration was not reloaded yet) SIM cards
        $( simsConfigured ).each( function( idx, sim ) {
            if( $.inArray( sim.ICCID, enabledICCIDs ) < 0 /* no match */ )
            {
                var $select = $( "#gateway-gsm-sim-cards-nap-tpl" ).clone().attr( { "id" : "nap-for-" + sim.ICCID } ).addClass( "gateway-gsm-sim-cards-config" ).change( changeNapCallback );
                $select.val( sim.NAP ? sim.NAP : '' ).change( );

                // current configuration SIM cards
                //@formatter:off
                var $label = $( "<label />" ).append( kuiInlineIcon( "notice", kuiInlineIconColors.blue, kuiInlineIconTextPosition.right, { title : ajaxI18NToLocaleCharset( 'gateway-need-configuration-reload' ) } ) )
                  .append( SimCardToString( sim ) )
                  .attr( {
                    "for" : "nap-for-" + sim.ICCID
                  } );
                  //$( "<input />" ).attr( { "type" : "hidden", "id" : "sim-" + sim.ICCID } ).val( sim.ICCID ).addClass( "gateway-gsm-sim-card" )
                $table.append(
                  $( "<tr />" ).append(
                    $( "<td />" ).append( $label ).append( createSimCardHiddenInput( sim.ICCID ) )
                  ).append(
                    $( "<td />" ).append( createNumberInput( "number-for-" + sim.ICCID ).val( sim.Number ) )
                  ).append(
                    $( "<td />" ).append( $select.show() )
                  ).append(
                    $( "<td />" ).append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/remove.png" } ).on( "click", deleteSimCard ) ).addClass( "gateway-table-options" )
                  )
                );
                //@formatter:on
            }
        } );

        $table.parent().tablesorter(
        {
            cssAsc : 'tablesorter-asc',
            cssDesc : 'tablesorter-desc',
            cssHeader : 'tablesorter-undefined',
            textExtraction :
            {
                0 : function( node, table, cellIndex )
                {
                    return $( node ).find( "input" ).val();
                },
                1 : function( node, table, cellIndex )
                {
                    return $( node ).find( "input" ).val();
                },
                2 : function( node, table, cellIndex )
                {
                    var val = $( node ).find( "select" ).val();
                    // not assigned
                    if( val == "" )
                    {
                        return $( node ).find( "select" ).find( "option:selected" ).text();
                    }
                    return val;
                }
            },
            headers :
            {
                3 :
                {
                    sorter : false
                }
            },
            sortList : [[0, 0]]
        } );
    } );

    $( '#gateway-gsm-sim-cards-add' ).off( "click" ).on( "click", addSimCard );
    $( '#gateway-gsm-sim-cards-save' ).off( "click" ).on( "click", save );
}

//@formatter:off
/*
 * TODO: advanced firewall configuration!
function initFirewallGW()
{
    var acldata = {};

    var getRule = function( idx )
    {
        if( idx == "CORE" )
        {
            return acldata.__CoreRule__;
        }
        else
        {
            return acldata.Rules[idx];
        }
    };

    var ruleOptionsToString = function( rule )
    {
        var str = "";

        var strPush = function( name, val )
        {
            if( str.length == 0 )
            {
                str = ajaxI18N( name ) + ": " + val;
            }
            else
            {
                str += ", " + ajaxI18N( name ) + ": " + val;
            }
        };

        switch( rule.Protocol )
        {
            default:
            case 'ANY':
            case 'ICMP':
                if( rule.ICMP && rule.ICMP.Type )
                {
                    strPush( "gateway-firewall-acl-rule-icmp-type", rule.ICMP.Type );
                }
                break;
            case 'TCP':
            case 'UDP':
                if( rule.IP )
                {
                    if( rule.IP.SourcePort )
                    {
                        strPush( "gateway-firewall-acl-rule-ip-source-port", rule.IP.SourcePort );
                    }
                    if( rule.IP.DestinationPort )
                    {
                        strPush( "gateway-firewall-acl-rule-ip-destination-port", rule.IP.DestinationPort );
                    }
                }
            case 'IP':
                if( rule.IP )
                {
                    if( rule.IP.StateIs )
                    {
                        var statestr = '';
                        $.each( rule.IP.StateIs, function( idx, state ) {
                            if( statestr.length > 0 )
                            {
                                statestr += "," + state;
                            }
                            else
                            {
                                statestr = state;
                            }
                        } );
                        strPush( "gateway-firewall-acl-rule-ip-stateis", statestr );
                    }
    
                    if( rule.IP.Track )
                    {
                        strPush( "gateway-firewall-acl-rule-ip-track", rule.IP.Track.Action );
    
                        if( rule.IP.Track.Action == "CHECK" )
                        {
                            strPush( "gateway-firewall-acl-rule-ip-track-hits", rule.IP.Track.Hits );
                            strPush( "gateway-firewall-acl-rule-ip-track-hitsttl", rule.IP.Track.HitsTTL );
                        }
                    }
                }
        }

        if( rule.RejectWith )
        {
            strPush( "gateway-firewall-acl-rule-reject-with", rule.RejectWith );
        }

        return str;
    };

    var mainTableRuleToString = function( rule, description )
    {
        var r = ruleOptionsToString( rule );
        if( r.length == 0 )
        {
            r = rule.Protocol;
        }
        else
        {
            r = rule.Protocol + ", " + r;
        }
        return description + " [" + r + "]";
    };

    var editProtocolOptions = function( ruleidx, idappend )
    {
        var $div = $( "<div />" );
        var $tbody = $( "<tbody />" );
        var rule = getRule( $( this ).parent().attr( "rule-index" ) );

        $div.append( $( "<table />" ).addClass( "gateway-table-modal-form" ).append( $tbody ) );

        switch( rule.Protocol )
        {
            case 'ANY':
                break;
            case 'ICMP':
                var icmptype = '';
                if( rule["ICMP"] != undefined && rule.ICMP["Type"] != undefined )
                {
                    icmptype = rule.ICMP.Type;
                }
                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-icmp-type', $( "<input />" ).val( icmptype ) );
                break;
            case 'TCP':
            case 'UDP':
                var sourceport = '', destinationport = '';

                if( rule["IP"] != undefined )
                {
                    if( rule.IP["SourcePort"] != undefined )
                    {
                        sourceport = rule.IP.SourcePort;
                    }
                    if( rule.IP["DestinationPort"] != undefined )
                    {
                        destinationport = rule.IP.DestinationPort;
                    }
                }

                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-source-port', $( "<input />" ).val( sourceport ) );
                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-destination-port', $( "<input />" ).val( destinationport ) );
                // no break
            case 'IP':
                var states = [], trackaction = 'NO_TRACK', trackhits = '', trackhitsttl = '';

                if( rule["IP"] != undefined )
                {
                    if( rule.IP["StateIs"] != undefined )
                    {
                        states = rule.IP.StateIs;
                    }
                    if( rule.IP["Track"] != undefined )
                    {
                        if( rule.IP.Track["Action"] != undefined )
                        {
                            trackaction = rule.IP.Track.Action;
                        }
                        if( rule.IP.Track["Hits"] != undefined )
                        {
                            trackhits = rule.IP.Track.Hits;
                        }
                        if( rule.IP.Track["HitsTTL"] != undefined )
                        {
                            trackhitsttl = rule.IP.Track.HitsTTL;
                        }
                    }
                }

                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-stateis', $( "#gateway-firewall-rule-ip-state-is-tmpl" ).clone().show().val( states ) );
                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-track', $( "#gateway-firewall-rule-ip-track-tmpl" ).clone().show().val( trackaction ) );
                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-track-hits', $( "<input />" ).val( trackhits ) );
                kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-ip-track-hitsttl', $( "<input />" ).val( trackhitsttl ) );
                break;
        }

        var rejectwith = '';
        if( rule["RejectWith"] != undefined )
        {
            rejectwith = rule.RejectWith;
        }
        kuiFormTableRow( $tbody, 'gateway-firewall-acl-rule-reject-with', $( "<input />" ).val( rejectwith ) );

        var onDialogClose = function()
        {
            // cleanup dialog divs
            $( this ).dialog( "destroy" );
            // self remove
            $( this ).remove();
        };

        $( "#gateway-firewall" ).append( $div );
        $div.dialog(
            {
                    closeOnEscape : true,
                    modal : true,
                    draggable : false,
                    resizable : false,
                    title : ajaxI18N( "gateway-firewall-acl-rule-protocol-options" ),
                    width : $( window ).width( ) - 240,
                    height : $( window ).height( ) - 160,
                    close : onDialogClose
                    //buttons : _buttons
            }
        );
    };

    var makeProtocolOptionsString = function( ruleindex, idappend )
    {
        var myid = "gateway-firewall-acl-protocol-options";
        if( idappend )
        {
            myid += idappend;
        }
        var $span = $( "<span />" )
            .attr( { 'id' : myid, 'rule-index' : ruleindex } )
            .text( ruleOptionsToString( getRule( ruleindex ), idappend ) );
        $span.append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/edit.png", "style" : "float: right" } ).on( "click", editProtocolOptions ) );

        return $span;
    };

    var initFirewallAcl = function( name )
    {
        var $acl = $( "<table />" ).attr( { "id" : "gateway-firewall-acl-form" } ).addClass( 'gateway-table-form' ).append( "<tbody />" );
        var $acltbody = $acl.children().first();

        $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=getFilterChain",
                type : "POST",
                dataType : "JSON",
                async : false,
                data : { 'name' : name, 'core' : false },
                success : function( data ) { acldata = data; },
                error : ajaxDefaultError
            }
        );

        console.log( acldata );

        var $nameinput = $( "<input />" ).attr( { type : "text" } ).val( acldata.Name );
        if( acldata.Name.length > 0 )
        {
            $nameinput.prop( {disabled: true});
        }
        var $protoselect = $( "#gateway-firewall-rule-protocol-tmpl" ).clone();
        $protoselect.val( acldata.__CoreRule__.Protocol ).show();

        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-name', $nameinput );
        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-description', $( "<input />" ).attr( { type : "text" } ).val( acldata.Description ) );
        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-rule-protocol', $protoselect );
        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-rule-protocol-options', makeProtocolOptionsString( "CORE" ) );

        $( "#gateway-firewall-acl-fs" ).append( $acl );

        var $rulestbody = $( '#gateway-firewall-acl-rules-table tbody' );

        $.each( acldata.Rules, function( idx, rule ) {
            var $rprotoselect = $( "#gateway-firewall-rule-protocol-tmpl" ).clone();
            $rprotoselect.select( rule.Protocol ).attr( { id : 'gateway-firewall-acl-rule-protocol-' + idx } ).val( rule.Protocol ).show();
            var $ractionselect = $( "#gateway-firewall-rule-action-tmpl" ).clone();
            $ractionselect.select( rule.Action ).attr( { id : 'gateway-firewall-acl-rule-action-' + idx } ).val( rule.Action ).show();

            var $tr = $( "<tr />" );
            $tr.append( $( "<td />" ).append( $( "<input />").attr( { id : 'gateway-firewall-acl-rule-source-address-' + idx } ).val( rule.SourceAddress ) ) );
            $tr.append( $( "<td />" ).append( $rprotoselect ) );
            $tr.append( $( "<td />" ).append( $ractionselect ) );
            $tr.append( $( "<td />" ).append( makeProtocolOptionsString( idx, "-" + idx ) ) );

            $rulestbody.append( $tr );
        } );
    };

    var TESTE_FirewallAcl = function( name, $placeholder )
    {
        var $acl = $( "<table />" ).attr( { "id" : "gateway-firewall-acl-form" } ).addClass( 'gateway-table-form' ).append( "<tbody />" );
        var $acltbody = $acl.children().first();

        $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=getFilterChain",
                type : "POST",
                dataType : "JSON",
                async : false,
                data : { 'name' : name, 'core' : false },
                success : function( data ) { acldata = data; },
                error : ajaxDefaultError
            }
        );

        console.log( acldata );

        var $nameinput = $( "<input />" ).attr( { type : "text" } ).val( acldata.Name );
        if( acldata.Name.length > 0 )
        {
            $nameinput.prop( {disabled: true});
        }
        var $protoselect = $( "#gateway-firewall-rule-protocol-tmpl" ).clone();
        $protoselect.val( acldata.__CoreRule__.Protocol ).show();

        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-description', $( "<input />" ).attr( { type : "text" } ).val( acldata.Description ) );
        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-rule-protocol', $protoselect );
        kuiFormTableRow( $acltbody, 'gateway-firewall-acl-rule-protocol-options', makeProtocolOptionsString( "CORE" ) );

        $placeholder.append( $acl );

        var $tbl = $( "<table />" )
            .attr( { "id" : "gateway-firewall-acl-form" } )
            .addClass( 'gateway-table-form' )
            .hide()
            .append( $( "<thead />" )
                .append( $( "<tr />")
                    .html( "<th>gateway-firewall-acl-rule-sourceaddress</th><th>gateway-firewall-acl-rule-protocol</th><th>gateway-firewall-acl-rule-action</th><th>gateway-firewall-acl-protocol-rule-options</th>" )
                )
            )
            .append( "<tbody />" );
        var $rulest = $( "<fieldset />" )
            .append( $( "<legend />" ).text( "+ Rules" ).click( function() { $( this ).next().toggle(); } ) )
            .append( $tbl );
        var $rulestbody = $tbl.find( "tbody" ).first();

        $.each( acldata.Rules, function( idx, rule ) {
            var $rprotoselect = $( "#gateway-firewall-rule-protocol-tmpl" ).clone();
            $rprotoselect.select( rule.Protocol ).attr( { id : 'gateway-firewall-acl-rule-protocol-' + idx } ).val( rule.Protocol ).show();
            var $ractionselect = $( "#gateway-firewall-rule-action-tmpl" ).clone();
            $ractionselect.select( rule.Action ).attr( { id : 'gateway-firewall-acl-rule-action-' + idx } ).val( rule.Action ).show();

            var $tr = $( "<tr />" );
            $tr.append( $( "<td />" ).append( $( "<input />").attr( { id : 'gateway-firewall-acl-rule-source-address-' + idx } ).val( rule.SourceAddress ) ) );
            $tr.append( $( "<td />" ).append( $rprotoselect ) );
            $tr.append( $( "<td />" ).append( $ractionselect ) );
            $tr.append( $( "<td />" ).append( makeProtocolOptionsString( idx, "-" + idx ) ) );

            $rulestbody.append( $tr );
        } );
        $placeholder.append( $rulest );
    };

    var editFirewallAcl = function()
    {
        var name = $( this ).attr( "Name" );
        $( "#refreshing" ).show();
        $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=showFilterChain',
                type : "GET",
                success : function( data )
                {
                    $( '#gateway-firewall' ).html( data );
                    initFirewallAcl( name );
                    $( "#refreshing" ).hide();
                },
                error : ajaxDefaultError
            }
        );
    };

    var deleteFirewallAcl = function()
    {
        var name = $( this ).attr( "Name" );
        //TODO: implement
    };

    var populateMainTable = function( data )
    {
        var $table = $( '#gateway-firewall-table tbody' );
        var descriptions = [];

        var $teste = $( "<div />" );

        $.kajax(
            {
                url : GLOBALAjaxURL + '&ajaxTo=getFilterChainDescriptions',
                type : "POST",
                dataType : "JSON",
                async : false,
                success : function( data ) { descriptions = data; },
                error : ajaxDefaultError
            }
        );
        $.each( data['Rules'], function( idx, rule ) {
            var $row = $( "<tr />" )
                .append( $( "<td />" ).text( rule["Chain"] ) )
                .append( $( "<td />" ).text( mainTableRuleToString( rule, descriptions[rule.Chain] ) ) )
                .append( $( "<td />" )
                    .append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/edit.png" } ).attr( { "Name" : rule["Chain"] } ).on( "click", editFirewallAcl ) )
                    .append( $( "<img />" ).prop( { "src" : image_dir + "/imagens/remove.png" } ).attr( { "Name" : rule["Chain"] } ).on( "click", deleteFirewallAcl ) )
                );
            $table.append( $row );

            var $teste2 = $( "<fieldset />" )
                .append( $( "<legend />" )
                    .append( kuiInlineIcon( "triangle-1-n", kuiInlineIconColors.black, kuiInlineIconTextPosition.none, {} ) )
                    .append( kuiInlineIcon( "triangle-1-s", kuiInlineIconColors.black, kuiInlineIconTextPosition.right, {} ) )
                    .append( $( "<span />" ).text( "ACL " + rule.Chain ) )
                );
            TESTE_FirewallAcl( rule.Chain, $teste2 );
            $teste.append( $teste2 );
        } );

        $table.hide();
        $( '#gateway-firewall' ).append( $teste );
    };

    $( "#refreshing" ).show();
    $.kajax(
        {
            url : GLOBALAjaxURL + '&ajaxTo=getFilterChain',
            type : "POST",
            dataType : "JSON",
            data : { 'name' : 'INPUT', 'core' : true },
            async : false,
            success : populateMainTable,
            error : ajaxDefaultError
        }
    );

    $( '#gateway-firewall-add-acl' ).attr( { "Name" : "" } ).on( "click", editFirewallAcl );
    $( "#refreshing" ).hide();
}
*/
//@formatter:on

function initFirewallGW()
{
    var chain;
    var $fieldset = $( "#gateway-firewall" );
    I18NReadToCache( [
        'gateway-firewall',
        'gateway-firewall-simple-help',
        'gateway-firewall-simple-accept',
        'gateway-firewall-simple-drop',
        'gateway-firewall-simple-drop-all',
        'gateway-firewall-simple-saving',
        'gateway-firewall-staged',
        'gateway-firewall-commited',
        'gateway-firewall-error-network',
        'gateway-firewall-error-possible-lock-out-rollback-in-progress',
        'closeDropDown'
    ], true );

    var deleteAddress = function( )
    {
        var $this = $( this );
        // the input text
        var $input = $this.parent().children().first();

        if(
            $input.hasClass( "gateway-firewall-simple-accept-input" )
            // drop all is checked
            && $( "#gateway-firewall-simple-drop-all" ).is( ":checked" )
            // and this is the last element from accept being removed
            && $( "[class~='gateway-firewall-simple-accept-input']" ).length == 1
        )
        {
            $( "#gateway-firewall-simple-drop-all" ).prop( "checked", false ).change();
        }
        //      li
        $this.parent().remove();
    };

    var focusoutAddress = function( )
    {
        // if the input text is empty, then remove it on focus out...
        if( $.trim( $( this ).val() ) == '' )
        {
            $( this ).next().click();
        }
    };

    var pushIpAddress = function( $list, useroptions )
    {
        var defaults = {
            value : '',
            inputclass : '',
            inputsetfocus : false
        };

        var options = $.extend( {}, defaults, useroptions );

        var $input = $( "<input />" )
            .attr( { type : "text" } )
            .addClass( options.inputclass )
            .val( options.value )
            .focusout( focusoutAddress );

        $list.append( $( "<li />" )
            .append( $input )
            .append(
                kuiIconButton( "close", {}, deleteAddress, kuiInlineIconColors.white, kuiIconButtonColors.lightgreen )
            )
        );

        if( options.inputsetfocus )
        {
            $input.focus();
        }
    };

    var addClick = function()
    {
        pushIpAddress( $( this ).data( 'list' ), $( this ).data( 'options' ) );
    };

    var saveClick = function()
    {
        var savedialog = $( "<div />" )
            .append( $( "<div />" )
                .addClass( "textAlignCenter" )
                .append( $( "<br />" ) )
                .append( $( "<img />" ).attr( { "src" : "../imagens/refreshing.gif" } ) )
                .append( $( "<br />" ) )
                .append( $( "<br />" ) )
                .append( ajaxI18NToLocaleCharset( "gateway-firewall-simple-saving" ) )
        );
        var $div = savedialog.children().first();

        savedialog.dialog( {
            modal : true,
            closeOnEscape : false,
            draggable : false,
            resizable : false,
            width : $( window ).width( ) - 240,
            height : $( window ).height( ) - 160
        } );

        savedialog.parent().find( "button" ).remove();

        var mydata = { 'ACCEPT' : [ ], 'DROP' : [ ] };
        $( '.gateway-firewall-simple-accept-input' ).each( function( ) {
            mydata['ACCEPT'].push( $( this ).val() );
        } );
        if( $( '#gateway-firewall-simple-drop-all' ).is( ':checked' ) )
        {
            mydata['DROP'].push( 'ANY' );
        }
        else
        {
            $( '.gateway-firewall-simple-drop-input' ).each( function( ) {
                mydata['DROP'].push( $( this ).val() );
            } );
        }

        var staged = false;
        // stage the new configuration
        console.log( mydata );
        $.kajax(
            {
                url : GLOBALAjaxURL + "&ajaxTo=stageSimpleFilter",
                type : "POST",
                async : false,
                data : mydata,
                dataType : "JSON",
                success : function( data )
                {
                    var spanclass = "";
                    staged = data.success;
                    if( !staged )
                    {
                        spanclass = "gateway-firewall-error";
                    }
                    $div.append( $( "<br />" ) )
                        .append( $( "<span />" )
                            .html( data.message )
                            .addClass( spanclass )
                        );
                },
                error : function( )
                {
                    $div.append( $( "<br />" ) )
                        .append( $( "<span />" )
                            .html( ajaxI18N( 'gateway-firewall-error-network' ) )
                            .addClass( "gateway-firewall-error" )
                        );
                }
            }
        );

        var closeButton = function() {
            $div.find( "img" ).first().hide();

            $div.append( $( "<br />" ) )
                .append( $( "<br />" ) )
                .append( $( "<input />" )
                .attr( { type : "button" } )
                .addClass( "ui-button ui-widget ui-state-default" )
                .val( ajaxI18NToLocaleCharset( 'closeDropDown' ) )
                .click( function() {
                    savedialog.dialog( "destroy" ).remove();
                } )
            );
        };

        if( staged )
        {
            // commit the new configuration
            setTimeout( function() {
                $.kajax(
                    {
                        url : GLOBALAjaxURL + "&ajaxTo=commitFirewallConfiguration",
                        type : "POST",
                        async : false,
                        dataType : "JSON",
                        success : function( data )
                        {
                            var spanclass = "";
                            if( !data.success )
                            {
                                spanclass = "gateway-firewall-error";
                            }
                            $div.append( $( "<br />" ) )
                                .append( $( "<span />" )
                                    .html( data.message )
                                    .addClass( spanclass )
                                );
                        },
                        error : function( )
                        {
                            $div.append( $( "<br />" ) )
                                .append( $( "<span />" )
                                    .html( ajaxI18N( 'gateway-firewall-error-possible-lock-out-rollback-in-progress' ) )
                                    .addClass( "gateway-firewall-error" )
                                );
                        }
                    }
                );
                closeButton();
            }, 8000 );
        }
        else
        {
            closeButton();
        }
    };

    $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=getFilterChain",
            type : "POST",
            dataType : "JSON",
            async : false,
            data : { 'name' : 'ALWAYS-ACCEPT', 'core' : false },
            success : function( data ) { chain = data; },
            error : ajaxDefaultError
        }
    );

    var $acceptfs = $( "<fieldset />" )
        .append( $( "<legend />" ).html( ajaxI18N( 'gateway-firewall-simple-accept' ) ) );
    var $acceptlist = $( "<ul />" )
        .attr( { 'id': 'gateway-firewall-simple-accept' } );

    $.each( chain.Rules, function( idx, rule ) {
        pushIpAddress( $acceptlist, { value: rule.SourceAddress, attributes: {}, inputclass: "gateway-firewall-simple-accept-input" } );
    } );

    $acceptfs
        .append( $acceptlist )
        .append( $( "<input />" )
            .attr( {
                "type" : "button"
            } )
            .data( 'list', $acceptlist )
            .data( 'options', { inputclass: "gateway-firewall-simple-accept-input", inputsetfocus : true } )
            .val( ajaxI18NToLocaleCharset( "add" ) )
            .click( addClick )
    );

    $.kajax(
        {
            url : GLOBALAjaxURL + "&ajaxTo=getFilterChain",
            type : "POST",
            dataType : "JSON",
            async : false,
            data : { 'name' : 'ALWAYS-DROP', 'core' : false },
            success : function( data ) { chain = data; },
            error : ajaxDefaultError
        }
    );

    var $dropfs = $( "<fieldset />" )
        .append( $( "<legend />" ).html( ajaxI18N( 'gateway-firewall-simple-drop' ) ) );
    var $droplist = $( "<ul />" )
        .attr( { 'id': 'gateway-firewall-simple-drop' } );

    $dropfs
        .append( $( "<input />" )
            .attr( { type : "checkbox", id : "gateway-firewall-simple-drop-all" } )
            .data( 'fieldsetdrop', $dropfs )
            .data( 'fieldsetaccept', $acceptfs )
            .change( function( evt ) {
                var $this = $( this );
                if( $this.is( ":checked" ) )
                {
                    if( $this.data( "fieldsetaccept" ).find( "[class~='gateway-firewall-simple-accept-input']" ).length == 0 )
                    {
                        ShowNotice( ajaxI18NToLocaleCharset( "gateway-firewall-simple-drop-all-need-at-least-one-input-rule" ), false );
                        $this.prop( "checked", false );
                        evt.preventDefault();
                    }
                    else
                    {
                        $this.data( "fieldsetdrop" ).find( "div" ).first().hide();
                    }
                }
                else
                {
                    $this.data( "fieldsetdrop" ).find( "div" ).first().show();
                }
            } )
        )
        .append( $( "<label />" ).attr( { "for" : "gateway-firewall-simple-drop-all" } ).html( ajaxI18N( "gateway-firewall-simple-drop-all" ) ) )
        .append( $( "<br />" ) )
        .append( $( "<div />" )
            .append( $droplist )
            .append( $( "<input />" )
                .attr( {
                    type : "button",
                    id : "gateway-firewall-simple-drop-add"
                } )
                .data( 'list', $droplist )
                .data( 'options', { inputclass: "gateway-firewall-simple-drop-input", inputsetfocus : true } )
                .val(ajaxI18NToLocaleCharset( "add" ))
                .click( addClick )
        )
    );

    if( chain.Rules.length == 1 && chain.Rules[0].SourceAddress == "ANY" )
    {
        $dropfs.find( "#gateway-firewall-simple-drop-all" ).prop( "checked", true ).change( );
    }
    else
    {
        $dropfs.find( "#gateway-firewall-simple-drop-all" ).prop( "checked", false ).change( );
        $.each( chain.Rules, function( idx, rule ) {
            pushIpAddress( $droplist, { value: rule.SourceAddress, attributes: {}, inputclass: "gateway-firewall-simple-drop-input" } );
        } );
    }

    $fieldset
        .append( $( "<p />" ).html( ajaxI18N( 'gateway-firewall-simple-help' ) ) )
        .append( $acceptfs )
        .append( $dropfs )
        .append( $( "<br />" ) )
        .append( $( "<div >" )
            .attr( { 
                'class' : 'floatRight'
            }) 
        .append( $( "<input />" )
            .attr( { type : "button" } )
            .val( ajaxI18N( "save" ) )
            .click( saveClick )
        ));
}

function downloadConfigurationFiles()
{
    if( document.cookie.indexOf("klockdownloadbutton") >= 0 )
        if( $.cookie( "klockdownloadbutton" ) == "true" )
            return;

    var date = new Date();
    date.setTime( date.getTime() + 1000 );

    $.cookie( "klockdownloadbutton", "true", { expires: date } );

    $( "#refreshing" ).show();

    kgatewayrpc.DownloadConfigurationFiles().then( function( err, files )
    {
        $( "#refreshing" ).hide();

        if( err )
        {
            ShowNotice( err['message'], false );
            return;
        }

        var files_url = "../cgi-bin/service.cgi/file_handler";
        files_url += "?filetype=generated";
        files_url += "&filename=" + files["filename"];
        files_url += "&displayname=kmg-configuration.tar.gz";

        $.fileDownload( files_url );
    } );
}

function uploadConfigurationFiles( e )
{
    e.preventDefault();

    if( $( "#provisioning-upload-file" ).data( "files" ) == undefined )
    {
        ajaxAlert( "provisioning-select", false );
        return;
    }

    var files = $( "#provisioning-upload-file" ).data( "files" );

    if( files.length < 1 )
    {
        ajaxAlert( "provisioning-select", false );
        return;
    }

    if( files[0].size > 2097152 )
    {
        ajaxAlert( "provisioning-size", false );
        return;
    }

    if( !( /\.tar\.gz$/.test( files[0].name ) ) )
    {
        ajaxAlert( "provisioning-type", false );
        return;
    }

    var data = new FormData();

    data.append( 0, files[0] );

    $( "#refreshing" ).show();

    $.ajax(
    {
        url: "../cgi-bin/service.cgi/file_handler",
        type: "POST",
        data: data,
        cache: false,
        processData: false,
        contentType: false,
        async: true,
        success: function( response )
        {
            kgatewayrpc.UploadConfigurationFiles(
                { filename: response } ).then( function( err, data )
            {
                $( "#refreshing" ).hide();

                if( err )
                {
                    ajaxAlert( "provisioning-upload-invalid", false );
                    return;
                }

                document.forms["uploadform"].reset();

                ajaxAlert( "provisioning-uploaded", true );

                alert( ajaxI18N( "provisioning-reboot" ) );
            } );
        },
        error: function( xhr, ajaxOptions, thrownError )
        {
            $( "#refreshing" ).hide();

            ajaxAlert( "provisioning-upload-error", false );
        },
    } );
}

function configurationFilesSetup()
{
    $( "#provisioning-download" ).off( "click" );
    $( "#provisioning-download" ).on( "click", downloadConfigurationFiles );
    $( "#provisioning-upload-send" ).off( "click" );
    $( "#provisioning-upload-send" ).on( "click", uploadConfigurationFiles );

    $( "#provisioning-upload-file" ).off( "change" );
    $( "#provisioning-upload-file" ).on( "change", function( e )
    {
        $( "#provisioning-upload-file" ).data( "files", e.target.files );
    } );
}
