<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN http://www.w3.org/TR/ht        ml4/strict.dtd">
<html>
    <head>
        <title>KWebMonitor</title>
        <meta http-equiv="content-type" content="text/html; charset=utf-8" />
        <link href="{$MODULO_PAI}/imagens/khomp.ico" rel="shortcut icon">
        
        <link rel="stylesheet" type="text/css" media="screen" href="{$MODULO}/estilos/kwebmonitor.css?{$KWEBMONITOR_CSS_TS}">
        <link rel="stylesheet" type="text/css" media="screen" href="{$MODULO_PAI}/js/geral.css?{$GERAL_CSS_TS}">
        <link rel="stylesheet" type="text/css" href="{$MODULO}/estilos/jquery.jqplot.min.css?{$JQPLOT_CSS_TS}" />
        
        <link rel="stylesheet" type="text/css" media="screen" href="{$MODULO_PAI}/js/jquery/css/ui-khomp/jquery-ui-1.10.4.custom.min.css?{$UI_CSS_TS}">
        <link rel="stylesheet" type="text/css" media="screen" href="{$MODULO_PAI}/js/jquery/css/k-ui.css?{$K_UI_CSS_TS}">

        {$JS_CONFLICT}
        {$ELASTIX_CSS_CORRECTION}
        
        <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.js?{$JQUERY_JS_TS}" ></script>
        <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.ui.js?{$JQUERY_UI_JS_TS}" ></script>
        <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/chosen.jquery.min.js?{$CHOSEN_JS_TS}"></script>
        <script type="text/javascript" src="{$MODULO_PAI}/js/khookies.js?{$GERAL_JS_TS}"></script>
        <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.cookie.js?{$COOKIE_JS_TS}"></script>
        
        <script type="text/javascript" src="{$MODULO_PAI}/js/geral.js?{$GERAL_JS_TS}"></script>
        <script type="text/javascript" src="{$MODULO}/js/util.js?{$UTIL_JS_TS}"></script>
        <script type="text/javascript" src="{$MODULO}/js/kwebmonitor.js?{$KWEBMONITOR_JS_TS}"></script>

        {if $IS_GATEWAY}
            <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.ui.js?{$JQUERY_UI_JS_TS}"></script>
            <script type="text/javascript" src="{$MODULO_PAI}/js/compatibility.js?{$COMPATIBILITY_JS_TS}"></script>
            <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/rpc-0.2.1.min.js?{$RPC_JS_TS}"></script>
            <script type="text/javascript" src="{$MODULO}/js/kgateway.js?{$KGATEWAY_JS_TS}"></script>
            <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.maskedinput-1.3.min.js?{$MASKINPUT_JS_TS}"></script>
            <script type="text/javascript" src="{$MODULO_PAI}/js/jquery/jquery.tablesorter.min.js?{$TABLESORT_JS_TS}"></script>
        {/if}
        
        <script type="text/javascript" src="{$MODULO}/js/kcharts.js?{$KCHART_TS}"></script>
        <script type="text/javascript" src="{$MODULO}/js/jquery.jqplot.min.js?{$JQPLOT_JS_TS}"></script>
        <script type="text/javascript" src="{$MODULO}/js/jqplot.pieRenderer.min.js?{$JQPLOT_PIE_JS_TS}"></script>

        <script type="text/javascript">
            var SO = '{$SO}';
            var desvioX = '{$DESVIO_X}';
            var desvioY = '{$DESVIO_Y}';
            var image_dir = '{$MODULO_PAI}';
            var modulo_dir = '{$MODULO}';
        </script>

    </head>
    <body onload="getRefreshDelay('{$JSmodule}');setAccordianMenu();">
        <div class='blockscreen displayNone' onclick="hideDiv();"> </div>

        <div id="bar">
            <img src="{$MODULO_PAI}/imagens/verde-topo.jpg">
        </div>
        <div id="khomp">
            <div class="blockscreenError"></div>

            {$TOP}

            <div class="botoes">
            {if $IS_GATEWAY}
                <input id='naps-button' value='{$NAPS}' onclick="window.location = 'index.php?location=naps'" type='button' />
                {if $HAVE_GSM}
                    <input id='simcards-button' value='{$SIMCARDS}' onclick="window.location = 'index.php?location=simcards'" type='button' />
                {/if}
            {/if}
            <input id='devices-button' class="monitor-menu-button" value='{$DEVICES}' onclick="window.location = 'index.php?location=devices';colorMe(this.id);" type='button' />
            <input id="links-button" class="monitor-menu-button" value="{$LINKS}" onclick="window.location = 'index.php?location=links';colorMe(this.id);" type="button" />
            <input id="channels-button" class="monitor-menu-button" value="{$CHANNELS}" onclick="window.location = 'index.php?location=channels';colorMe(this.id);" type="button" />

            {if ! $IS_GATEWAY}
                <input id="services-button" class="monitor-menu-button" value="{$SERVICES}" onclick="window.location = 'index.php?location=services';colorMe(this.id);" type="button" />
            {/if}

            </div>
            <div id="refreshNow">
                <img src="{$MODULO_PAI}/imagens/refresh.png" id="refresh" class="cursorHand" title="{$REFRESH}" onclick="updateData{$MODULE}(true);"/>
                <img src="{$MODULO_PAI}/imagens/refreshing.gif" style="display:none;" id="refreshing" border="0"/>
            </div>

            <div id="divRefreshDelay">
                {$REFRESH_DELAY}
                 <select id="refreshDelay" onchange="setRefreshDelay( {literal}$( this ).val(){/literal},'{$MODULE}');">
                    <option {$SEL_NOT_REFRESH} value="0">{$NOT_REFRESH}</option>
                    <option {$SEL_DELAY1} value="30">{$DELAY1}</option>
                    <option {$SEL_DELAY2} value="10">{$DELAY2}</option>
                    <option {$SEL_DELAY3} value="2">{$DELAY3}</option>
                </select>
            </div>
            <br/>
            <br/>
            <br/>
            <fieldset class="fieldsetConteudo">
                <legend>
                    {$LEGEND}
                </legend>
                <div id="popup"> </div>

                <div id='saved_notice'>
                    <div class="close cursorPointer" onclick="closeShowNotice();">X</div>
                    <span>message</span>
                </div>
                <div id="monitor-content">
                    {$CONTENT}
                </div>
                <input type="hidden" value="false" id="ctrlMonitoracao" />

                <input id="channelsStatusChartTitle" type="hidden" value="{$CH_STATUS_CHART_TITLE}" />
                <input id="incOutChartTitle" type="hidden" value="{$INC_OUT_CHART_TITLE}" />
                <input id="statusChartTitle" type="hidden" value="{$STATUS_CHART_TITLE}" />
                <input id="failChartTitle" type="hidden" value="{$FAIL_CHART_TITLE}" />

                <input type="hidden" id="chartKey" value="" />
                <div id="deviceCharts" class="displayNone">
                    <ul>
                        <li><a onclick="createChannelStatusChart('deviceChartsHolder','serial');" href='#tabs-0'>{$CHANNELS}</a></li>
                        <li><a onclick="createCallStatsChart('deviceChartsHolder', 'serial');" href='#tabs-0'>{$CALLS}</a></li>
                        <li><a onclick="createFailStatsChart('deviceChartsHolder', 'serial');" href='#tabs-0'>{$REASON_FAILS}</a></li>
                        <input type="button" value="{$REFRESH_CHARTS}" class="refreshCharts" onclick="refreshCharts();"/>
                    </ul>
                    <div class="refreshingChartDiv" id="tabs-0">
                        <img class='refreshingCharts' src="{$MODULO_PAI}/imagens/refreshing.gif" />
                    </div>
                    <div class="noDataChart" > </div>
                    <div id="deviceChartsHolder" class=".chart">
                        <div class="simpleChart"> </div>
                        <div class="doubleChart">
                            <div class='dbc1'> </div>
                            <div class='dbc2'> </div>
                        </div>
                    </div>
                </div>
                <div id="linkCharts" class="displayNone">
                    <ul>
                        <li><a onclick="createChannelStatusChart('linkChartsHolder','serial.link');" href='#tabs-1'>{$CHANNELS}</a></li>
                        <li><a onclick="createCallStatsChart('linkChartsHolder', 'serial.link');" href='#tabs-1'>{$CALLS}</a></li>
                        <li><a onclick="createFailStatsChart('linkChartsHolder', 'serial.link');" href='#tabs-1'>{$REASON_FAILS}</a></li>
                        <input type="button" value="{$REFRESH_CHARTS}" class="refreshCharts" onclick="refreshCharts();"/>
                    </ul>
                    <div class="refreshingChartDiv" id="tabs-1">
                        <img class='refreshingCharts' src="{$MODULO_PAI}/imagens/refreshing.gif" />
                    </div>
                    <div class="noDataChart" > </div>
                    <div id="linkChartsHolder" class=".chart">
                        <div class="simpleChart"> </div>
                        <div class="doubleChart">
                            <div class='dbc1'> </div>
                            <div class='dbc2'> </div>
                        </div>
                    </div>
                </div>
                <div id="channelCharts" class="displayNone">
                    <ul>
                        <li><a onclick="createCallStatsChart('channelChartsHolder', 'serial.channel');" href='#tabs-2'>{$CALLS}</a></li>
                        <li><a onclick="createFailStatsChart('channelChartsHolder', 'serial.channel');" href='#tabs-2'>{$REASON_FAILS}</a></li>
                        <input type="button" value="{$REFRESH_CHARTS}" class="refreshCharts" onclick="refreshCharts();"/>
                    </ul>
                    <div class="refreshingChartDiv" id="tabs-2">
                        <img class='refreshingCharts' src="{$MODULO_PAI}/imagens/refreshing.gif" />
                    </div>
                    <div class="noDataChart" > </div>
                    <div id="channelChartsHolder" class=".chart">
                        <div class="simpleChart"> </div>
                        <div class="doubleChart">
                            <div class='dbc1'> </div>
                            <div class='dbc2'> </div>
                        </div>
                    </div>
                </div>
            </fieldset>
            <br/>
            <br/>
            {$FOOTER}
            <br/>

        </div>
    </body>
</html>